{ =====================================================
 Copyright (C) 2007 Francisco A. Ocana & Pablo Onate 

 This file is part of IndElec

 IndElec is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 IndElec is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You have received a copy of the GNU General Public License
 in a file called COPYING which you should have received with
 IndElec. If not, see <http://www.gnu.org/licenses/>.
 ===================================================== 
}
unit ADIMENSI;

{
 This is the main unit which manages the computing process to obtain
the political indices from a given election with no aggregation levels.

  Programa para obtener las dimensiones o caractersticas relativas
  a unos comicios electorales (una sla eleccin) .

  Dispone de una utilidad para obtener los ndices corregidos
  a distintos umbrales.

 }

INTERFACE

{$N+}


uses COMUN, DIMDEFN, DIMMEDN,
     ADIMINOU, ADIMMED,
     Dialogs;


procedure adimensiw(var infoFi: TOInfoFich);

IMPLEMENTATION


procedure adimensiw(var infoFi: TOInfoFich);

var
   f: text;               { text file variable for the output files }

   nodat,                 { no. of parties (-1) with electoral support }
   noParti: TRgPartido;   { no. of parties (1) read from the data file }

   Pa: PVecParty;         { pointer to the vector of party records }

   tote,              { number of seats  }
   totv: Tnumero;      { number of votes }

begin
  iniDato(infoFi, f, noParti, nodat);

  CreaOrdenaDato(Pa, noParti, totv, tote, 'DATOS');

  { Begin output: text file }
  IniResultado(infoFi, f, noParti);
  writeDatoTXT(f, Pa, noParti, nodat, totv, tote);
  MedidasTXT(infoFi.camin, f, Pa, nodat, totv, tote);
  close(f);
  { End output: text file }
  
  {  Begin output: HTML file }
  iniResultHTML(infoFi, f, noParti);
  writeDatoHTML(f, Pa, noParti, nodat, totv, tote);
  MedidasHTML(infoFi.camin, f, Pa, nodat, totv, tote);
  close(f);
  { End output: HTML file }

  {  Begin output: R file }
  iniResultRS(infoFi, f, noParti);
  MedidasRS(infoFi.camin, f, Pa, nodat, totv, tote);
  close(f);
  { End output: R file }

  TheEnd(Pa, noParti);

  ShowMessage('Calculations done');
end;


END.
