{ =====================================================
 Copyright (C) 2007 Francisco A. Ocana & Pablo Onate 

 This file is part of IndElec

 IndElec is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 IndElec is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You have received a copy of the GNU General Public License
 in a file called COPYING which you should have received with
 IndElec. If not, see <http://www.gnu.org/licenses/>.
 ===================================================== 
}
unit ADIMMED;


{$N+}

INTERFACE

uses COMUN, DIMDEFN, DIMAUXN;



procedure CreaOrdenaDato(var Pa: PVecParty; noParti: TRgPartido;
                    var totv, tote: Tnumero; nomDat: TnombreFi);




IMPLEMENTATION


procedure CreaOrdenaDato(var Pa: PVecParty;  noParti: TRgPartido;
                  var totv, tote: Tnumero;  nomDat: TnombreFi);

{
 This procedure loads the vector "Pa" of electoral data from the
binary file "nomDat".aux, which is also sorted in decreasing order 
according to the number of seats. At the end, the initial content of 
"nomDat".aux is sorted too.

Ordena el contenido del fichero nomDat.aux en orden decreciente.
Crea el vector de partidos en "Pa" con los partidos ordenados
en orden decreciente al nmero de votos recibidos.
}

var
     i: TRgPartido;
     g: file of Tparty;


Begin
  GetMem(Pa, TlongNatural(Succ(noParti)) * sizeOf(Tparty) );

  assign(g, camIndElec+nomDat+'.aux');   reset(g);
  for i:= 0 to noParti do read(g, Pa^[i]);
  close(g);

  ordenaDato4vot(Pa, noParti);

  assign(g, camIndElec+nomDat+'.aux');   rewrite(g);
  for i:= 0 to noParti do write(g, Pa^[i]);
  close(g);

  IniNorma(totv, tote, Pa, noParti);
End;
{ **************************************************************** }

{
procedure CreacionDatos(var Pa1, Pa2: PVecParty;
                        noPart1, noPart2: TRgPartido);

 var totv, tote: Tnumero;

Begin
  CreaOrdenaDato(Pa1, noPart1, totv, tote, 'DATOS1');
  CreaOrdenaDato(Pa2, noPart2, totv, tote, 'DATOS2');
End;
}

{ end of adimMed }
END.
