{ =====================================================
 Copyright (C) 2007 Francisco A. Ocana & Pablo Onate 

 This file is part of IndElec

 IndElec is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 IndElec is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You have received a copy of the GNU General Public License
 in a file called COPYING which you should have received with
 IndElec. If not, see <http://www.gnu.org/licenses/>.
 ===================================================== 
}

unit AVOLATI;

INTERFACE

{$N+,E-}

USES COMUN, DIMDEFN, VOLDEF, ADIMMED,
     AVOLINOU, AVOLDIM, Dialogs;


procedure avolatiw(var infoFixx: TOInfoFich);

IMPLEMENTATION

procedure avolatiw(var infoFixx: TOInfoFich);

var
    cami1, cami2: TcaminFi;
    noPart1, noPart2,
    nodat1, nodat2: TRgPartido;
    Pa: PVecParty;
    f: text;
    Pvol: PVecVolati;
    dimVol: TRgPartido;
    sumEsc1, sumEsc2,
    sumVot1, sumVot2: Tnumero;

begin
  if iniDatoVol(cami1, cami2, infoFixx, noPart1, noPart2, nodat1, nodat2)
  then
    begin
      ShowMessage('Error: file not found.');
      exit;
    end;

{ 2nd election}
  CreaOrdenaDato(Pa, noPart2, sumVot2,sumEsc2, 'DATOS2');

  iniVolatili(Pvol, dimVol);
  assign(f, infoFixx.camin+infoFixx.nom+'.ivo');

  IniDistribu(f, Pvol,dimVol,Pa, noPart2, nodat2, FALSE, sumVot2,sumEsc2);
  delVectParty(Pa, noPart2);

{ 1st election}
  CreaOrdenaDato(Pa, noPart1, sumVot1,sumEsc1, 'DATOS1');

  IniDistribu(f, Pvol,dimVol,Pa, noPart1, nodat1, TRUE, sumVot1,sumEsc1);
  delVectParty(Pa, noPart1);

  close(f);

  { initialize the text file}
  iniResltadov(infoFixx, f, sumVot2, sumEsc2, sumVot1, sumEsc1);

  resultadovv(f, Pvol, dimVol, TRUE, sumVot2, sumVot1);
  resultadovv(f, Pvol, dimVol, FALSE, sumEsc2, sumEsc1);

  close(f);
  {end: initialize the text file }

  { creacin de fichero HTML }
  iniResltadovHT(infoFixx, f, sumVot2, sumEsc2, sumVot1, sumEsc1);

  resltadoHT(f, Pvol, dimVol, TRUE, sumVot2, sumVot1);
  resltadoHT(f, Pvol, dimVol, FALSE, sumEsc2, sumEsc1);

  close(f);
  {fin: creacin de fichero HTML }

  { creacin de fichero R }
  iniResltadovRS(infoFixx, f, sumVot2, sumEsc2, sumVot1, sumEsc1);

  resltadoRS(f, Pvol, dimVol, TRUE, sumVot2, sumVot1);
  resltadoRS(f, Pvol, dimVol, FALSE, sumEsc2, sumEsc1);

  close(f);
  {fin: creacin de fichero R }


  FreeMem(Pvol, sizeOf(TVolati) * TlongNatural(Succ(dimVol)));
  
  ShowMessage('Calculations done');
end;

END.
