{ =====================================================
 Copyright (C) 2007 Francisco A. Ocana & Pablo Onate 

 This file is part of IndElec

 IndElec is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 IndElec is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You have received a copy of the GNU General Public License
 in a file called COPYING which you should have received with
 IndElec. If not, see <http://www.gnu.org/licenses/>.
 ===================================================== 
}

unit AVOLDIM;

INTERFACE

{$N+,E-}

uses COMUN, DIMDEFN, VOLDEF, DIMSIGLA, VOLFORMU;



procedure IniDistribu(var fv: text;
                      Pvol: PVecVolati; dimVol: TRgPartido;
                      Pa: PVecParty; noParti, nodat: TRgPartido;
                      PRIMER: boolean;
                      var sumVot, sumEsc: Tnumero);

procedure resultadovv(var f: text;
                    Pvol: PVecVolati; dimVol: TRgPartido;
                    VOTOS: boolean; var sumPer2, sumPer1: Tnumero);

procedure resltadoHT(var f: text;
                    Pvol: PVecVolati; dimVol: TRgPartido;
                    VOTOS: boolean; var sumPer2, sumPer1: Tnumero);

procedure resltadoRS(var f: text;
                    Pvol: PVecVolati; dimVol: TRgPartido;
                    VOTOS: boolean; var sumPer2, sumPer1: Tnumero);


IMPLEMENTATION

uses UHTML, COMUTIL, ESCISIO;


procedure IniDistribu(var fv: text;
                      Pvol: PVecVolati; dimVol: TRgPartido;
                      Pa: PVecParty; noParti, nodat: TRgPartido;
                      PRIMER: boolean;
                      var sumVot, sumEsc: Tnumero);

  label encontrado;

  var siglax: TcadCandi;
      i, j: TRgPartido;
      localiza: boolean;
      saltoLinea, topeSalto: byte;

Begin
  if PRIMER then topeSalto:= 1
            else topeSalto:= 0;

  sumVot:= 0;  sumEsc:= 0;

  for j:= 0 to nodat do
    begin { 1 }
      reset(fv);

      for i:= 0 to 4 do readln(fv);

      localiza:= FALSE;

      for i:= 0 to dimVol do
        begin  { 2 }
          readln(fv);
          saltoLinea:= 0;

          repeat
            if leeCadenaLn(fv, @siglax, lenCandida)
            then
              Inc(saltoLinea)
            else
              begin
                if (saltoLinea = topeSalto) then
                  begin
                    localiza:= siglax = Pa^[j].SiglasCandi;

                    if localiza then
                      begin { 5 }
                        sumVot:= sumVot + Pa^[j].Vp;
                        sumEsc:= sumEsc + Pa^[j].Ep;

                        if PRIMER
                        then
                          begin
                            Pvol^[i].Vp:= Pvol^[i].Vp - Pa^[j].Vp;
                            Pvol^[i].Ep:= Pvol^[i].Ep - Pa^[j].Ep;
                          end
                        else
                          begin
                            Pvol^[i].Vp:= Pvol^[i].Vp + Pa^[j].Vp;
                            Pvol^[i].Ep:= Pvol^[i].Ep + Pa^[j].Ep;
                          end;

                        goto encontrado;
                      end; { 5 }
                  end;
              end;
          until (saltoLinea = 2) or Eof(fv);

        end; { 2 }

      encontrado:
    end;  { 1 }

  {FreeMem(Pa, TlongNatural( Succ(noParti) ) * sizeOf(Tparty));}
End;


procedure resultadovv(var f: text;
                    Pvol: PVecVolati; dimVol: TRgPartido;
                    VOTOS: boolean; var sumPer2, sumPer1: Tnumero);

  const
    tabColu = 10;
    preci = 3;

  var TV, BV, WV: Tnumero;
      vSimbo: TSimbAfili;
      NoBloq: byte;

Begin
  iniSimbolo(vSimbo, NoBloq);

  writeln(f);  writeln(f);
  write(f, 'INDICES AND PERCENTAGES OF ');
  if VOTOS then write(f, 'ELECTORAL ')
           else write(f, 'PARLIAMENTARY ');
  writeln(f, 'VOLATILITY');

  writeln(f);

  write(f, 'VT ':tabcolu);
  write(f, 'VB ':tabcolu);
  write(f, 'VIB ':tabcolu);

  write(f, '%VB ':tabcolu);
  writeln(f,'%VIB ':tabcolu);

  TV:= fTV(Pvol, dimVol, VOTOS);
  aprVolBM(TV,sumPer2,sumPer1);

  BV:= fBV(Pvol, dimVol, vSimbo, NoBloq, VOTOS);
  aprVolBM(BV,sumPer2,sumPer1);

  WV:= TV - BV;

  escridat(f, TV, tabColu, preci, FALSE, FALSE);
  escridat(f, BV, tabColu, preci, FALSE, FALSE);
  escridat(f, WV, tabColu, preci, FALSE, FALSE);

  BV:= 100*(BV/TV);
  escridat(f, BV, tabcolu, preci, FALSE, FALSE);

  WV:= 100*(WV/TV);
  escridat(f, WV, tabColu, preci, FALSE, TRUE);

  writeln(f);

  write(f, 'The Arian & Weiss index');

  if not(VOTOS) then write(f, ' (parliamentary version)');

  write(f, ' = ');
  WV:= fIEscision(Pvol, dimVol, VOTOS);
  escridat(f, WV, 5, preci, FALSE, TRUE);

  flush(f);
End;


procedure resltadoHT(var f: text;
                    Pvol: PVecVolati; dimVol: TRgPartido;
                    VOTOS: boolean; var sumPer2, sumPer1: Tnumero);

{ versin HTML de resultadovv }

  const  preci = 3;

  var TV, BV, WV: Tnumero;
      vSimbo: TSimbAfili;
      NoBloq: byte;

Begin
  iniSimbolo(vSimbo, NoBloq);

  writeln(f);  writeln(f, '<h2>');
  write(f, 'Indices and percentages of ');

  if VOTOS then writeln(f, 'electoral ')
           else writeln(f, 'parliamentary ');

  writeln(f, 'volatility</h2>');

  writeln(f, '<p> <table cellspacing="5">');
  writeln(f, '<tr>');
  writeHeadTabla(f, 'VT ', 'r');
  writeHeadTabla(f, 'VB ', 'r');
  writeHeadTabla(f, 'VIB ', 'r');

  writeHeadTabla(f, '%VB ', 'r');
  writeHeadTabla(f,'%VIB ', 'r');
  writeln(f, '</tr> <tr>');

  TV:= fTV(Pvol, dimVol, VOTOS);
  aprVolBM(TV,sumPer2,sumPer1);

  BV:= fBV(Pvol, dimVol, vSimbo, NoBloq, VOTOS);
  aprVolBM(BV,sumPer2,sumPer1);

  WV:= TV - BV;

  escridaHT(f, TV, preci);
  escridaHT(f, BV, preci);
  escridaHT(f, WV, preci);

  BV:= 100*(BV/TV);
  escridaHT(f, BV, preci);

  WV:= 100*(WV/TV);
  escridaHT(f, WV, preci);

  writeln(f, '</tr></table></p>');
  writeln(f);

  write(f, '<p><b>The Arian & Weiss index</b>');

  if not(VOTOS) then write(f, ' (parliamentary version)');

  write(f, ' = ');
  WV:= fIEscision(Pvol, dimVol, VOTOS);
  escridaHT(f, WV, preci);
  writeln(f, '</p>');

  writeln(f, '</body>');
  writeln(f, '</html>');
  flush(f);
End;


procedure resltadoRS(var f: text;
                    Pvol: PVecVolati; dimVol: TRgPartido;
                    VOTOS: boolean; var sumPer2, sumPer1: Tnumero);

  const preci = 3;

  var TV, BV, WV: Tnumero;
      vSimbo: TSimbAfili;
      NoBloq: byte;
      termi: string[8];

Begin
  iniSimbolo(vSimbo, NoBloq);

  write(f, '# INDICES AND PERCENTAGES OF ');
  if VOTOS then write(f, 'ELECTORAL ')
           else write(f, 'PARLIAMENTARY ');
  writeln(f, 'VOLATILITY');

  if VOTOS then termi:= '.e = '
           else termi:= '.p = ';

  write(f, 'VT'+termi);
  TV:= fTV(Pvol, dimVol, VOTOS);
  aprVolBM(TV,sumPer2,sumPer1);
  escridatLIST(f, TV, preci, TRUE, FALSE);

  write(f, 'VB'+termi);
  BV:= fBV(Pvol, dimVol, vSimbo, NoBloq, VOTOS);
  aprVolBM(BV,sumPer2,sumPer1);
  escridatLIST(f, BV, preci, TRUE, FALSE);

  write(f, 'VIB'+termi);
  WV:= TV - BV;
  escridatLIST(f, WV, preci, TRUE, FALSE);

  write(f, 'PVB'+termi);
  BV:= 100*(BV/TV);
  escridatLIST(f, BV, preci, TRUE, FALSE);

  write(f,'PVIB'+termi);
  WV:= 100*(WV/TV);
  escridatLIST(f, WV, preci, TRUE, FALSE);

  write(f, 'ArianWeiss'+termi);
  WV:= fIEscision(Pvol, dimVol, VOTOS);
  escridatLIST(f, WV, preci, VOTOS, not(VOTOS));

  if not(VOTOS) then writeln(f, ');');

  flush(f);
End;

END.
