{ =====================================================
 Copyright (C) 2007 Francisco A. Ocana & Pablo Onate 

 This file is part of IndElec

 IndElec is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 IndElec is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You have received a copy of the GNU General Public License
 in a file called COPYING which you should have received with
 IndElec. If not, see <http://www.gnu.org/licenses/>.
 ===================================================== 
}

unit AVOLINOU;


INTERFACE

{$N+,E-}

USES COMUN, DIMDEFN;


function iniDatoVol(var cami1, cami2: TcaminFi;
              var infoFixx: TOInfoFich;
              var noPart1, noPart2, nodat1, nodat2: TRgPartido): boolean;

procedure iniResltadov(var infoFixx: TOInfoFich; var fout: text;
              var sumVot2, sumEsc2, sumVot1, sumEsc1: Tnumero);

procedure iniResltadovHT(var infoFixx: TOInfoFich; var fout: text;
                 var sumVot2, sumEsc2, sumVot1, sumEsc1: Tnumero);

procedure iniResltadovRS(var infoFixx: TOInfoFich; var fout: text;
             var sumVot2, sumEsc2, sumVot1, sumEsc1: Tnumero);

IMPLEMENTATION


uses UHTML,COMUTIL, ADIMINOU, VOLDEF, VOLAGET, MEMBRETE;


procedure actuaDato(var f: text; var noParti, nodat: TRgPartido;
                    nomDat: TnombreFi);

  var
      g: file of Tparty;
      rpa: Tparty;

Begin
  readln(f);
  readln(f);

  assign(g, camIndElec+nomDat+'.aux');   rewrite(g);

  nodat:= 0;
  noParti:= 0;

  repeat
    leeParty(f, rpa);
    write(g, rpa);

    Inc(noParti);
    if rpa.Vp > 0 then Inc(nodat);

  until Eof(f);

  close(g);
  close(f);

  if nodat > 0 then Dec(nodat);

  if noParti > 0 then Dec(noParti);
End;



function iniDatoVol(var cami1, cami2: TcaminFi;
             var infoFixx: TOInfoFich;
             var noPart1, noPart2, nodat1, nodat2: TRgPartido): boolean;

  var nom1, nom2: TnombreFi;
      f: text;

Begin
  assign(f, infoFixx.camin + infoFixx.nom +'.ivo');   reset(f);

  readln(f);
  readln(f, nom2);
  readln(f);
  readln(f, nom1);

  close(f);

  if InicVolati(cami1, cami2, infoFixx) then
    begin
      IniDatoVol:= TRUE;
      exit;
    end;

  {$I-}
  assign(f, cami1+nom1+'.dat');   reset(f);
  {$I+}

  if IoResult <> 0 then
    begin
      iniDatoVol:= TRUE;
      exit;
    end;

  actuaDato(f, noPart1, nodat1, 'DATOS1');

  {$I-}
  assign(f, cami2+nom2+'.dat');   reset(f);
  {$I+}

  if IoResult <> 0 then
    begin
      iniDatoVol:= TRUE;
      exit;
    end;

  actuaDato(f, noPart2, nodat2, 'DATOS2');

  iniDatoVol:= FALSE;
End;

procedure iniResltadov(var infoFixx: TOInfoFich; var fout: text;
                 var sumVot2, sumEsc2, sumVot1, sumEsc1: Tnumero);

  var camid: TcaminFi;
      nomf: TnombreFi;
      fs: text;
      
Begin
  assign(fs, infoFixx.camin+infoFixx.nom+'.ivo');   reset(fs);

  assign(fout, infoFixx.camin+infoFixx.nom+'.res');  rewrite(fout);

  MmbrIndx(fout, 1, 't');

  write(fout, 'DATA FROM THE SECOND ELECTION: ');

  readln(fs, camid);    readln(fs, nomf);
  checkPath(camid);
  writeln(fout, camid+nomf+'.dat');

  writeln(fout);

  write(fout, 'DATA FROM THE FIRST ELECTION: ');

  readln(fs, camid);    readln(fs, nomf);
  checkPath(camid);
  writeln(fout, camid+nomf+'.dat');

  close(fs);

  ShowSimbolo(fout);

  writeln(fout);
  writeln(fout, 'Percentages explained by the considered parties');
  writeln(fout, 'in the blocs defined by the user');
  write(fout, '%Votes-2':12);
  write(fout, '%Seats-2':12);
  write(fout, '%Votes-1':12);
  writeln(fout, '%Seats-1':12);

  write(fout, '******':12);
  write(fout, '******':12);
  write(fout, '******':12);
  writeln(fout, '******':12);

  escridat(fout, sumVot2, 12, 2, FALSE, FALSE);
  escridat(fout, sumEsc2, 12, 2, FALSE, FALSE);
  escridat(fout, sumVot1, 12, 2, FALSE, FALSE);
  escridat(fout, sumEsc1, 12, 2, FALSE, TRUE);

  flush(fout);
End;

procedure iniResltadovHT(var infoFixx: TOInfoFich; var fout: text;
                 var sumVot2, sumEsc2, sumVot1, sumEsc1: Tnumero);

{ versin HTML de iniResltadov }

  var camid: TcaminFi;
      nomf: TnombreFi;
      fs: text;
      
Begin
  assign(fs, infoFixx.camin+infoFixx.nom+'.ivo');   reset(fs);

  assign(fout, infoFixx.camin+infoFixx.nom+'.htm');  rewrite(fout);

  writeln(fout, '<html>');
  writeln(fout, '<head>');
  IntroMetaHTML(fout);
  write(fout, '<title>');
  writeln(fout, infoFixx.nom);
  writeln(fout, '</title></head>');
  writeln(fout, '<body>');

  MmbrIndx(fout, 1, 'h');

  writeln(fout, '<p>');
  write(fout, '<b>Data from the second election:</b> ');

  readln(fs, camid);    readln(fs, nomf);
  checkPath(camid);
  writeln(fout, camid+nomf+'.dat');
  writeln(fout, '<br>');

  write(fout, '<b>Data from the first election:</b> ');

  readln(fs, camid);    readln(fs, nomf);
  checkPath(camid);
  writeln(fout, camid+nomf+'.dat');
  writeln(fout, '</p>');

  close(fs);

  writeln(fout, '<pre>');
  ShowSimbolo(fout);
  writeln(fout, '</pre>');

  writeln(fout, '<h3>');
  writeln(fout, 'Percentages explained by the considered parties');
  writeln(fout, 'in the blocs defined by the user</h3>');

  writeln(fout, '<p><table cellspacing="10">');
  writeln(fout, '<tr>');
  writeHeadTabla(fout, '%Votes-2', 'r');
  writeHeadTabla(fout, '%Seats-2', 'r');
  writeHeadTabla(fout, '%Votes-1', 'r');
  writeHeadTabla(fout, '%Seats-1', 'r');
  writeln(fout, '</tr> <tr>');

  escridaHT(fout, sumVot2,  2);
  escridaHT(fout, sumEsc2, 2);
  escridaHT(fout, sumVot1, 2);
  escridaHT(fout, sumEsc1, 2);
  writeln(fout, '</tr></table></p>');

  flush(fout);
End;

procedure iniResltadovRS(var infoFixx: TOInfoFich; var fout: text;
                       var sumVot2, sumEsc2, sumVot1, sumEsc1: Tnumero);

  var camid: TcaminFi;
      nomf: TnombreFi;
      fs: text;
      
Begin
  assign(fs, infoFixx.camin+infoFixx.nom+'.ivo');   reset(fs);

  assign(fout, infoFixx.camin+infoFixx.nom+'.R'); rewrite(fout);

  MmbrIndx(fout, 1, 'r');

  write(fout, '# DATA FROM THE SECOND ELECTION: ');

  readln(fs, camid);    readln(fs, nomf);
  checkPath(camid);
  writeln(fout, camid+nomf+'.dat');

  writeln(fout, '#');

  write(fout, '# DATA FROM THE FIRST ELECTION: ');

  readln(fs, camid);    readln(fs, nomf);
  checkPath(camid);
  writeln(fout, camid+nomf+'.dat');

  writeln(fout, '#');

  close(fs);

  writeln(fout, '#');
  writeln(fout, '# Percentages explained by the considered parties');
  writeln(fout, '# in the blocs defined by the user');
  writeln(fout, '#');

  write(fout, 'Pencent.explained <- list(');
  write(fout, 'Elec2.Vote =');
  escridatLIST(fout, sumVot2, 2, TRUE, FALSE);

  write(fout, 'Elec2.Seat = ');
  escridatLIST(fout, sumEsc2, 2, TRUE, FALSE);

  write(fout, 'Elec1.Vote = ');
  escridatLIST(fout, sumVot1, 2, TRUE, FALSE);

  write(fout, 'Elec1.Seat = ');
  escridatLIST(fout, sumEsc1, 2, FALSE, TRUE);
  writeln(fout, ');');

  writeln(fout);

  writeln(fout, '# VOLATILITY');
  writeln(fout);

  write(fout, 'VOLATILITY <- list(');

  flush(fout);
End;


END.
