{ =====================================================
 Copyright (C) 2007 Francisco A. Ocana & Pablo Onate 

 This file is part of IndElec

 IndElec is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 IndElec is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You have received a copy of the GNU General Public License
 in a file called COPYING which you should have received with
 IndElec. If not, see <http://www.gnu.org/licenses/>.
 ===================================================== 
}
unit CABECERA;
{
Routines which includes the acronyms of the computed indices in 
the output files of IndElec.
}

INTERFACE

uses COMUN;


procedure cabeDespro(var fout: text);
procedure cabeDesproH(var fout: text);
procedure cabeDesproCSV(var fout: text);


procedure cabeDesproRobu(var fout: text);
procedure cabeDesproRobuH(var fout: text);
procedure cabeDesproRobuCSV(var fout: text);

procedure CabeSesgo(var fout: text);
procedure CabeSesgoH(var fout: text);
procedure CabeSesgoCSV(var fout: text);


procedure CabeFragConceCompe(var fout: text);
procedure CabeFragConceCompeH(var fout: text);
procedure CabeFragConceCompeCSV(var fout: text);


procedure cabeNoEfect(var fout: text);
procedure cabeNoEfectH(var fout: text);
procedure cabeNoEfectCSV(var fout: text);


procedure cabePolari(var fout: text);
procedure cabePolariH(var fout: text);
procedure cabePolariCSV(var fout: text);

procedure cabeVolatil(var fout: text);
procedure cabeVolatilCSV(var fout: text);
procedure cabeVolatilHH(var fout: text);


IMPLEMENTATION

uses  DEFNIVEL, UHTML;

const tabu = 7;  {look at DIMINOUN* }


procedure cabeDespro(var fout: text);
  var i: byte;
Begin
  writeln(fout, ' 1.- INDICES OF DISPROPORTIONALITY');

  writeln(fout);

  write(fout, '':lenCadItmNiv);   write(fout, #9);
  for i:= 1 to nnDspro do
    begin
      write(fout, i: tabu);  write(fout, #9);
    end;
  writeln(fout);

  write(fout, ' ': lenCadItmNiv);  write(fout, #9);
  write(fout, 'SL': tabu);    write(fout, #9);
  write(fout, 'R': tabu);     write(fout, #9);
  write(fout, 'Rco':tabu);    write(fout, #9);
  write(fout, 'LH': tabu);    write(fout, #9);
  write(fout, 'MR': tabu);    write(fout, #9);
  write(fout, 'GroE':tabu);   write(fout, #9);
  write(fout, 'GroP':tabu);   write(fout, #9);
  write(fout, 'Lmax': tabu);  write(fout, #9);
  write(fout, '#': tabu);     write(fout, #9);
  write(fout, 'Gmc': tabu);   write(fout, #9);
  write(fout, 'Lmc': tabu);   writeln(fout, #9);
  flush(fout);
End;




procedure cabeDesproRobu(var fout: text);
  var i: byte;
Begin
  writeln(fout);
  writeln(fout);
  writeln(fout, ' 2.- ROBUST INDICES OF DISPROPORTIONALITY');

  writeln(fout);

  write(fout, '': lenCadItmNiv);      write(fout, #9);

  for i:= 1 to nnDsRobu do
    begin
      write(fout, i: tabu);
      write(fout, #9);
    end;
  writeln(fout);

  write(fout, ' ': lenCadItmNiv);     write(fout, #9);
  write(fout, 'L1': tabu);       write(fout, #9);
  write(fout, 'L2': tabu);       write(fout, #9);
  write(fout, 'Loo':tabu);       write(fout, #9);
  write(fout, ' #': tabu);       writeln(fout, #9);
  flush(fout);
End;


procedure CabeSesgo(var fout: text);
Begin
  writeln(fout);
  writeln(fout);
  writeln(fout, ' 3.- INDICES OF BIAS');
  writeln(fout);
  write(fout, ' ': lenCadItmNiv);      write(fout, #9);
  write(fout, 'CS':tabu);         write(fout, #9);
  write(fout, 'r2':tabu);         write(fout, #9);
  write(fout, 'CSco': tabu);      write(fout, #9);
  write(fout, 'r2': tabu);        write(fout, #9);
  write(fout, 'CscF': tabu);      write(fout, #9);
  write(fout, 'r2': tabu);       write(fout, #9);
  write(fout, 'Robu': tabu);      write(fout, #9);
  write(fout, 'RbRe': tabu);     write(fout, #9);
  write(fout, 'RbRf': tabu);       write(fout, #9);
  write(fout, 'Rb05': tabu);     writeln(fout, #9);
  flush(fout);
End;


procedure CabeFragConceCompe(var fout: text);
  var i: byte;
Begin
  writeln(fout);
  writeln(fout);
  writeln(fout, ' 4.- INDICES OF FRAGMENTATION (Frag), CONCENTRATION (Cc) &');
  writeln(fout, '     COMPETITIVITY (Cmp)');
  writeln(fout);

  write(fout, '': lenCadItmNiv);  write(fout, #9);
  for i:= 1 to nnFrgCCcm do
    begin
      write(fout, i: tabu);
      write(fout, #9);
    end;

  writeln(fout);

  write(fout, ' ': lenCadItmNiv);    write(fout, #9);
  write(fout, 'Frag_e': tabu);   write(fout, #9);
  write(fout, 'Frag_p': tabu);   write(fout, #9);
  write(fout, 'Cc_e': tabu);    write(fout, #9);
  write(fout, 'Cc_p': tabu);    write(fout, #9);
  write(fout, 'Cmp_e': tabu);   write(fout, #9);
  write(fout, 'Cmp_p': tabu);   writeln(fout, #9);
  flush(fout);
End;


procedure cabeNoEfect(var fout: text);
  var i: byte;
Begin
  writeln(fout);
  writeln(fout);
  writeln(fout, ' 5.- EFFECTIVE NUMBER OF PARTIES');
  writeln(fout);

  write(fout, ' ': lenCadItmNiv);  write(fout, #9);
  for i:= 1 to nnNoEff do
    begin
      write(fout, i: tabu);
      write(fout, #9);
    end;
  writeln(fout);

  write(fout, ' ': lenCadItmNiv);      write(fout, #9);
  write(fout, 'N_e': tabu);       write(fout, #9);
  write(fout, 'N_p': tabu);       write(fout, #9);
  write(fout, 'DiN': tabu);       write(fout, #9);
  write(fout, 'I_e': tabu);       write(fout, #9);
  write(fout, 'I_p': tabu);       write(fout, #9);
  write(fout, 'DiI': tabu);       write(fout, #9);
  write(fout, 'NP_e': tabu);      write(fout, #9);
  write(fout, 'NP_p': tabu);      write(fout, #9);
  write(fout, 'DiNP': tabu);      writeln(fout, #9);
  flush(fout);
End;

procedure cabePolari(var fout: text);
  var i: byte;
Begin
  writeln(fout, ' 6.- INDICES OF POLARIZATION');

  writeln(fout);

  write(fout, '': lenCadItmNiv);   write(fout, #9);
  for i:= 1 to nnPolar do
    begin
      write(fout, i: tabu);  write(fout, #9);
    end;
  writeln(fout);

  write(fout, ' ': lenCadItmNiv);   write(fout, #9);
  write(fout, 'PSa': tabu);    write(fout, #9);
  write(fout, 'PP_e': tabu);   write(fout, #9);
  write(fout, 'PP_p': tabu);   write(fout, #9);
  write(fout, 'DiPP': tabu);   writeln(fout, #9);
  flush(fout);
End;


procedure cabeDesproH(var fout: text);
  var i: byte;
Begin
  writeln(fout, '<h2>1.- Indices of disproportionality</h2>');

  writeln(fout, '<p> <table cellspacing="10" border="0"> <tr>');

  writeln(fout, '<th> </th>');

  for i:= 1 to nnDspro do
    begin
      write(fout, '<td align="right">');
      write(fout, i);
      writeln(fout, '</td>');
    end;
  writeln(fout, '</tr>  <tr> <th> </th>');
  writeHeadTabla(fout, 'SL', 'r');
  writeHeadTabla(fout, 'R', 'r');
  writeHeadTabla(fout, 'Rco', 'r');
  writeHeadTabla(fout, 'LH', 'r');
  writeHeadTabla(fout, 'MR', 'r');
  writeHeadTabla(fout, 'GroE', 'r');
  writeHeadTabla(fout, 'GroP', 'r');
  writeHeadTabla(fout, 'Lmax', 'r');
  writeHeadTabla(fout, '#', 'r');
  writeHeadTabla(fout, 'Gmc', 'r');
  writeHeadTabla(fout, 'Lmc', 'r');
  writeln(fout, '</tr>');
  flush(fout);
End;


procedure cabeDesproRobuH(var fout: text);
  var i: byte;
Begin
  writeln(fout, '<h2>2.- Robust indices of disproportionality</h2>');

  writeln(fout, '<p> <table cellspacing="10" border="0">');

  write(fout, '<tr> <th> </th>');

  for i:= 1 to nnDsRobu do
    begin
      write(fout, '<td align="right">');
      write(fout, i);
      write(fout, '</td>');
    end;
  writeln(fout, '</tr> <tr> <th> </th>');
  writeHeadTabla(fout, 'L<sub>1</sub>', 'r');
  writeHeadTabla(fout, 'L<sub>2</sub>', 'r');
  writeHeadTabla(fout, 'L<sub>oo</sub>', 'r');
  writeHeadTabla(fout, ' #', 'r');
  writeln(fout, '</tr>');
  flush(fout);
End;


procedure CabeSesgoH(var fout: text);
Begin
  writeln(fout, '<h2>3.- Indices of bias</h2>');

  writeln(fout, '<p> <table cellspacing="10" border="0">');

  writeln(fout, '<tr> <th> </th>');
  writeHeadTabla(fout, 'CS', 'r');
  writeHeadTabla(fout, 'r<sup>2</sup>', 'r');
  writeHeadTabla(fout, 'CSco', 'r');
  writeHeadTabla(fout, 'r<sup>2</sup>', 'r');
  writeHeadTabla(fout, 'CscF', 'r');
  writeHeadTabla(fout, 'r<sup>2</sup>', 'r');
  writeHeadTabla(fout, 'Robu', 'r');
  writeHeadTabla(fout, 'RbRe', 'r');
  writeHeadTabla(fout, 'RbRf', 'r');
  writeHeadTabla(fout, 'Rb05', 'r');
  writeln(fout, '</tr>');
  flush(fout);
End;


procedure CabeFragConceCompeH(var fout: text);
  var i: byte;
Begin
  writeln(fout, '<h2>4.- Indices of fragmentation(Frag), Concentration(Cc) &');
  writeln(fout, 'Competitivity (Cmp)</h2>');

  writeln(fout, '<p> <table cellspacing="8" border="0">');

  writeln(fout, '<tr> <th> </th>');

  for i:= 1 to nnFrgCCcm do
    begin
      write(fout, '<td align="right">');
      write(fout, i);
      write(fout, '</td>');
    end;

  writeln(fout, '</tr> <tr> <th> </th>');
  writeHeadTabla(fout, 'Frag<sub>e</sub>', 'r');
  writeHeadTabla(fout, 'Frag<sub>p</sub>', 'r');
  writeHeadTabla(fout, 'Cc<sub>e</sub>', 'r');
  writeHeadTabla(fout, 'Cc<sub>p</sub>', 'r');
  writeHeadTabla(fout, 'Cmp<sub>e</sub>', 'r');
  writeHeadTabla(fout, 'Cmp<sub>p</sub>', 'r');
  writeln(fout, '</tr>');
  flush(fout);
End;


procedure cabeNoEfectH(var fout: text);
  var i: byte;
Begin
  writeln(fout, '<h2>5.- Effective number of parties</h2>');

  writeln(fout, '<p><table cellspacing="8" border="0">');
  writeln(fout, '<tr>');

  writeln(fout, '<th> </th>');
  for i:= 1 to nnNoEff do
    begin
      write(fout, '<td align="right">');
      write(fout, i);
      writeln(fout, '</td>');
    end;
  writeln(fout, '</tr> <tr> <th> </th>');
  writeHeadTabla(fout, 'N<sub>e</sub>', 'r');
  writeHeadTabla(fout, 'N<sub>p</sub>', 'r');
  writeHeadTabla(fout, 'DiN', 'r');
  writeHeadTabla(fout, 'I<sub>e</sub>', 'r');
  writeHeadTabla(fout, 'I<sub>p</sub>', 'r');
  writeHeadTabla(fout, 'DiI', 'r');
  writeHeadTabla(fout, 'NP<sub>e</sub>', 'r');
  writeHeadTabla(fout, 'NP<sub>p</sub>', 'r');
  writeHeadTabla(fout, 'DiNP', 'r');
  writeln(fout, '</tr>');
  flush(fout);
End;


procedure cabePolariH(var fout: text);
  var i: byte;
Begin
  writeln(fout, '<h2>6.- Indices of polarization</h2>');

  writeln(fout, '<p><table cellspacing="8" border="0"><tr>');

  writeln(fout, '<th> </th>');
  for i:= 1 to nnPolar do
    begin
      write(fout, '<td align="right">');
      write(fout, i);
      writeln(fout, '</td>');
    end;
  writeln(fout, '</tr> <tr> <th> </th>');
  writeHeadTabla(fout, 'PSa', 'r');
  writeHeadTabla(fout, 'PP<sub>e</sub>', 'r');
  writeHeadTabla(fout, 'PP<sub>p</sub>', 'r');
  writeHeadTabla(fout, 'DiPP', 'r');
  writeln(fout, '</tr>');
  flush(fout);
End;


procedure cabeDesproCSV(var fout: text);
  var i: byte;
Begin
  writeln(fout, '" 1.- INDICES OF DISPROPORTIONALITY"');

  writeln(fout);

  for i:= 1 to nnDspro do
    begin
      write(fout, sepacsv);
      write(fout, i);
    end;
  writeln(fout);

  write(fout, sepacsv);
  write(fout, '"SL"', sepacsv);
  write(fout, '"R"', sepacsv);
  write(fout, '"Rco"', sepacsv);
  write(fout, '"LH"', sepacsv);
  write(fout, '"MR"', sepacsv);
  write(fout, '"GroE"', sepacsv);
  write(fout, '"GroP"', sepacsv);
  write(fout, '"Lmax"', sepacsv);
  write(fout, '" #"', sepacsv);
  write(fout, '"Gmc"', sepacsv);
  writeln(fout, '"Lmc"');
  flush(fout);
End;

procedure cabeDesproRobuCSV(var fout: text);
  var i: byte;
Begin
  writeln(fout);
  writeln(fout);
  writeln(fout, '" 2.- ROBUST INDICES OF DISPROPORTIONALITY"');

  writeln(fout);

  for i:= 1 to nnDsRobu do
    begin
      write(fout, sepacsv);
      write(fout, i);
    end;
  writeln(fout);

  write(fout, sepacsv);
  write(fout, '"L1"', sepacsv);
  write(fout, '"L2"', sepacsv);
  write(fout, '"Loo"', sepacsv);
  writeln(fout, '" #"');      
  flush(fout); 
End;


procedure CabeSesgoCSV(var fout: text);
Begin
  writeln(fout);
  writeln(fout);
  writeln(fout, '" 3.- INDICES OF BIAS"');
  writeln(fout);
  write(fout, sepacsv);
  write(fout, '"CS"', sepacsv);
  write(fout, '"r2"', sepacsv);
  write(fout, '"CSco"', sepacsv);
  write(fout, '"r2"', sepacsv);
  write(fout, '"CscF"', sepacsv);
  write(fout, '"r2"', sepacsv);
  write(fout, '"Robu"', sepacsv);
  write(fout, '"RbRe"', sepacsv);
  write(fout, '"RbRf"', sepacsv);
  writeln(fout, '"Rb05"');
  flush(fout);
End;


procedure CabeFragConceCompeCSV(var fout: text);
  var i: byte;
Begin
  writeln(fout);
  writeln(fout);
  writeln(fout, '" 4.- INDICES OF FRAGMENTATION (Frag), CONCENTRATION (Cc) & "');
  writeln(fout, '"     COMPETITIVITY (Cmp)"');
  writeln(fout);

  for i:= 1 to nnFrgCCcm do
    begin
      write(fout, sepacsv);
      write(fout, i);
    end;

  writeln(fout);

  write(fout, sepacsv);
  write(fout, '"Frag_e"', sepacsv);
  write(fout, '"Frag_p"', sepacsv);
  write(fout, '"Cc_e"', sepacsv);
  write(fout, '"Cc_p"', sepacsv);
  write(fout, '"Cmp_e"', sepacsv);
  writeln(fout, '"Cmp_p"');
  flush(fout);
End;


procedure cabeNoEfectCSV(var fout: text);
  var i: byte;
Begin
  writeln(fout);
  writeln(fout);
  writeln(fout, '" 5.- EFFECTIVE NUMBER OF PARTIES"');
  writeln(fout);

  for i:= 1 to nnNoEff do
    begin
      write(fout, sepacsv);
      write(fout, i);
    end;
  writeln(fout);

  write(fout, sepacsv);
  write(fout, '"N_e"', sepacsv);
  write(fout, '"N_p"', sepacsv);
  write(fout, '"DiN"', sepacsv);
  write(fout, '"I_e"', sepacsv);
  write(fout, '"I_p"', sepacsv);
  write(fout, '"DiI"', sepacsv);
  write(fout, '"NP_e"', sepacsv);
  write(fout, '"NP_p"', sepacsv);
  writeln(fout, '"DiNP"');   
  flush(fout);   
End;

procedure cabePolariCSV(var fout: text);
  var i: byte;
Begin
  writeln(fout, '" 6.- INDICES OF POLARIZATION"');

  writeln(fout);

  for i:= 1 to nnPolar do
    begin
      write(fout, sepacsv);
      write(fout, i);
    end;
  writeln(fout);

  write(fout, sepacsv);
  write(fout, '"PSa"', sepacsv);
  write(fout, '"PP_e"', sepacsv);
  write(fout, '"PP_p"', sepacsv);
  writeln(fout, '"DiPP"');  
  flush(fout); 
End;


procedure cabeVolatil(var fout: text);
  var i: byte;
Begin
  writeln(fout, ' INDICES OF VOLATILITY');

  writeln(fout);

  write(fout, '': lenCadItmNiv);   write(fout, charTabu);
  for i:= 1 to 10 do
    begin
      write(fout, i: tabu);  write(fout, charTabu);
    end;
  writeln(fout);

  write(fout, ' ': lenCadItmNiv);    write(fout, charTabu);
  write(fout, 'TV_e': tabu);    write(fout, charTabu);
  write(fout, 'BV_e': tabu);    write(fout, charTabu);
  write(fout, 'IBV_e':tabu);    write(fout, charTabu);
  write(fout, '%BV_e': tabu);   write(fout, charTabu);
  write(fout, '%IBV_e': tabu);  write(fout, charTabu);

  write(fout, 'TV_p': tabu);    write(fout, charTabu);
  write(fout, 'BV_p': tabu);    write(fout, charTabu);
  write(fout, 'IBV_p':tabu);    write(fout, charTabu);
  write(fout, '%BV_p': tabu);   write(fout, charTabu);
  write(fout, '%IBV_p': tabu);  writeln(fout);
  flush(fout);
End;



procedure cabeVolatilCSV(var fout: text);
  var i: byte;
Begin
  writeln(fout, '"INDICES OF VOLATILITY"');

  writeln(fout);

  for i:= 1 to 10 do
    begin
      write(fout, sepacsv);
      write(fout, i);
    end;
  writeln(fout);

  write(fout, sepacsv);
  write(fout, '"TV_e"', sepacsv);
  write(fout, '"BV_e"', sepacsv);
  write(fout, '"IBV_e"', sepacsv);
  write(fout, '"%BV_e"', sepacsv);
  write(fout, '"%IBV_e"', sepacsv);

  write(fout, '"TV_p"', sepacsv);
  write(fout, '"BV_p"', sepacsv);
  write(fout, '"IBV_p"', sepacsv);
  write(fout, '"%BV_p"', sepacsv);
  writeln(fout, '"%IBV_p"'); 
  flush(fout);
End;
{ ********************************************** }


procedure cabeVolatilHH(var fout: text);
  var i: byte;
Begin
  writeln(fout, '<p><h3>Indices of volatility</h3></p>');

  writeln(fout, '<p><table cellspacing="10">');

  writeln(fout, '<tr> <td> </td>');
  for i:= 1 to 10 do
    begin
      write(fout, '<td align="right">');
      write(fout, i);
      writeln(fout, '</td>');
    end;
  writeln(fout, '</tr> <tr> ');

  write(fout, '<td> </td>');
  writeHeadTabla(fout, 'TV<sub>e</sub>', 'r');
  writeHeadTabla(fout, 'BV<sub>e</sub>', 'r');
  writeHeadTabla(fout, 'IBV<sub>e</sub>', 'r');
  writeHeadTabla(fout, '%BV<sub>e</sub>', 'r');
  writeHeadTabla(fout, '%IBV<sub>e</sub>', 'r');

  writeHeadTabla(fout, 'TV<sub>p</sub>', 'r');
  writeHeadTabla(fout, 'BV<sub>p</sub>', 'r');
  writeHeadTabla(fout, 'IBV<sub>p</sub>', 'r');
  writeHeadTabla(fout, '%BV<sub>p</sub>', 'r');
  writeHeadTabla(fout, '%IBV<sub>p</sub>', 'r');

  writeln(fout, '</tr>');
  flush(fout);
End;


END.