{ =====================================================
 Copyright (C) 2007 Francisco A. Ocana & Pablo Onate 

 This file is part of IndElec

 IndElec is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 IndElec is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You have received a copy of the GNU General Public License
 in a file called COPYING which you should have received with
 IndElec. If not, see <http://www.gnu.org/licenses/>.
 ===================================================== 
}
unit DIMDEFN;

{ 
Definition of the party data structures considered in calculations.
As data involved in calculations are stored in dynamic memory arrays,
memory capabilities are maintained under minimun requirements with
these data structures. 

Unidad que contiene las definiciones de DIMENSI por niveles. 
}

{$N+}

INTERFACE

uses COMUN;


type
  Tparty = record
    SiglasCandi: TcadCandi;  { the party acronym }
    Vp,                { votes }
    Ep: Tnumero;       { seats }
    PANE: boolean;     { Is it a PANE party? (this also has auxiliary functionalities) }
  end;

  TVecParty = array[0..NoMaxParti] of Tparty;

  PVecParty = ^TVecParty;

  TFichParty = file of Tparty;

procedure dimVectParty(var Pp: PVecParty; no: TRgPartido);

procedure delVectParty(var Pp: PVecParty; no: TRgPartido);  

IMPLEMENTATION

procedure dimVectParty(var Pp: PVecParty; no: TRgPartido);
Begin
  GetMem(Pp, TlongNatural(sizeOf(TParty))*Succ(no));
End;

procedure delVectParty(var Pp: PVecParty; no: TRgPartido);
Begin
  FreeMem(Pp, TlongNatural(sizeOf(TParty))*Succ(no));
End;

{ End of dimDefn }

END. 

