{ =====================================================
 Copyright (C) 2007 Francisco A. Ocana & Pablo Onate 

 This file is part of IndElec

 IndElec is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 IndElec is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You have received a copy of the GNU General Public License
 in a file called COPYING which you should have received with
 IndElec. If not, see <http://www.gnu.org/licenses/>.
 ===================================================== 
}
unit DIMINOUH;

{ 
HTML version of dimInOuN 

Create the HTML file with report style from the output of
the module Dimensi with data aggregation levels.

}

interface

uses COMUN;

procedure ShowFiHTML(var camino: TcaminFi;
                     NoNiveleUti, IndNivelAgrMx: byte);


implementation

uses DEFNIVEL, COMUTIL, DIMSIGLA, DIMDEFN,
     DIMVECTO, DIMAUXN,
     DIMENSIU, DIMREG, DIMESTIM, UINPOUT,MEMBRETE, CABECERA, UHTML;


const  preci = 2;

{ **************************************************************** }


procedure ShowSesgoH(var fout: text; var gout: Tfichero;
            var NoItms: TItmsNivel;  NoRegIniFich: word;
            preci, NoDimenss: byte);

{
   NoRegIniFich = Nmero de registros iniciales del fichero,
           tabu = amplitud tabulador,
          preci = precisin,
      NoDimenss = nmero total de registros por items,
}

  var b, r2: Tnumero;
      j: TItmsNivel;
      rniv: TRegNivel;
      i: byte;
      posIni: word;

 procedure pendiRobu(ponR2: boolean);
 Begin
    read(gout, b, r2);

    if r2 > 0
    then
      begin
        escridaHT(fout, b, preci);
        if ponR2 then escridaHT(fout, r2, preci);
      end
     else
      begin
        writeln(fout, '<td> </td>');
        if ponR2 then
          begin
            writeln(fout, '<td> </td>');
          end;
      end;
 End;


Begin
  reset(gout);

  read(gout, r2);    NoItms:= Trunc(r2);

  posIni:= NoRegIniFich + EqNo + iiSesg;
    {NoRegIniFich + EqNo + 16;}

  for j:= 0 to NoItms do
    begin
      seek(gout, NoRegIniFich);
      ReadNivel(gout, rniv);

      writeln(fout, '<tr>');
      writeItmTabla(fout, rniv.NomNivel, 'l');

      seek(gout, posIni);

      for i:= 1 to nnSesgLS do pendiRobu(TRUE);

      for i:= 1 to nnSesgTuk do pendiRobu(FALSE);

      writeln(fout, '</tr>');

      Inc(posIni, NoDimenss);
      Inc(NoRegIniFich, NoDimenss);
    end;

  flush(fout);
End;
{ *************************************************************}

procedure escrituraSesgH(var fout: text;
                        var gy: Tfichero; posi: word);

 const nnSesg1 = nnSesg - 1; { 6 }


  var j: byte;
      rx: Tnumero;
      crx: char absolute rx;
Begin
  for j:= 0 to nnSesg1 do
    begin
      seek(gy, posi);
      read(gy, rx);

      if crx = '*'
      then
        write(fout, '<td> </td>')
      else
        escridaHt(fout, rx, preci);
  
      if j < nnSesgLS then write(fout, '<td> </td>');
        
      Inc(posi, 5);
    end;

  writeln(fout, '</tr>');
End;


procedure ShowEstima1SesgoH(var fout: text);
  var gy: Tfichero;

Begin
  assign(gy, camIndElec+'datum.aux');  reset(gy);

  writeln(fout, '<tr>');
  writeItmTabla(fout, ' Min', 'l');
  escrituraSesgH(fout, gy, 0);

  writeln(fout, '<tr>');
  writeItmTabla(fout, ' Q1', 'l');
  escrituraSesgH(fout, gy, 1);

  writeln(fout, '<tr>');
  writeItmTabla(fout, ' Me', 'l');
  escrituraSesgH(fout, gy, 2);

  writeln(fout, '<tr>');
  writeItmTabla(fout, ' Q3', 'l');
  escrituraSesgH(fout, gy, 3);

  writeln(fout, '<tr>');
  writeItmTabla(fout, ' Max', 'l');
  escrituraSesgH(fout, gy, 4);

  close(gy);
  flush(fout);
End;
{ **************************************************************** }



procedure ShowMedidaH(var fout: text; var gout: Tfichero;
                      ClaseDistrito: boolean);

   const NoRegIni = 2;
        NoDimensD = EqNo + 1 + NNIndexs ; { = EqNo + 47 }
        

  var NoItms: TItmsNivel;
      med: PVector;
      Rc: PMatrix;

Begin
  ShowSignifica('despropo', 'h', fout);
  cabeDesproH(fout);
  ShowMedidaxH(fout, gout, NoItms, NoRegIni, iiDspro, nnDspro, preci, NoDimensD);
  if NoItms = 0
  then
     writeln(fout, '</table></p>')
  else
    begin
      ShowEstimasH(fout, gout, NoItms, NoRegIni, iiDspro, nnDspro,
                   preci, NoDimensD, med, Rc, cdistri);
      if ClaseDistrito then
        ShowEstimClaseH(fout, gout, NoItms, NoRegIni, iiDspro, nnDspro,
                      preci, NoDimensD, med, Rc, cdistri);
    end;


  ShowSignifica('DespRobu', 'h', fout);
  cabeDesproRobuH(fout);
  ShowMedidaxH(fout, gout, NoItms, NoRegIni, iiDsRobu, nnDsRobu, preci, NoDimensD);
  if NoItms = 0
  then
    writeln(fout, '</table></p>')
  else
    begin
      ShowEstimasH(fout, gout, NoItms, NoRegIni,iiDsRobu,nnDsRobu,
                  preci, NoDimensD, med, Rc, cdistri);
      if ClaseDistrito then
        ShowEstimClaseH(fout, gout, NoItms, NoRegIni,iiDsRobu,nnDsRobu,
                      preci, NoDimensD, med, Rc, cdistri);

    end;


  ShowSignifica('sesgos', 'h', fout);
  cabeSesgoH(fout);
  ShowSesgoH(fout, gout, NoItms, NoRegIni, preci, NoDimensD);
  if NoItms = 0
  then
    writeln(fout, '</table></p>')
  else
    begin
      IniEstimaxSesgo(gout, NoItms, NoRegIni, NoDimensD);
      Estimar1(nnsesg);
      ShowEstima1SesgoH(fout);
    end;


  ShowSignifica('fragCCcm', 'h', fout);
  cabeFragConceCompeH(fout);
  ShowMedidaxH(fout, gout, NoItms, NoRegIni,iiFrgCCcm,nnFrgCCcm, preci, NoDimensD);
  if NoItms = 0
  then
     writeln(fout, '</table></p>')
  else
    begin
      ShowEstimasH(fout, gout, NoItms, NoRegIni, iiFrgCCcm, nnFrgCCcm,
                   preci, NoDimensD, med, Rc, cdistri);
      if ClaseDistrito then
        ShowEstimClaseH(fout, gout, NoItms, NoRegIni, iiFrgCCcm, nnFrgCCcm,
                     preci, NoDimensD, med, Rc, cdistri);

    end;


  ShowSignifica('noEfecti', 'h', fout);
  cabeNoEfectH(fout);
  ShowMedidaxH(fout, gout, NoItms, NoRegIni, iiNoEff, nnNoEff, preci, NoDimensD);
  if NoItms = 0
  then
     writeln(fout, '</table></p>')
  else
    begin
      ShowEstimasH(fout, gout, NoItms, NoRegIni,iiNoEff,nnNoEff,
                   preci, NoDimensD, med, Rc, cdistri);
      if ClaseDistrito then
        ShowEstimClaseH(fout, gout, NoItms, NoRegIni,iiNoEff,nnNoEff,
                     preci, NoDimensD, med, Rc, cdistri);

    end;


  ShowSignifica('polariza', 'h', fout);
  cabePolariH(fout);
  ShowMedidaxH(fout, gout, NoItms, NoRegIni, iiPolar, nnPolar, preci, NoDimensD);
  if NoItms = 0
  then
    writeln(fout, '</table></p>')
  else
    begin
      ShowEstimasH(fout, gout, NoItms, NoRegIni, iiPolar,nnPolar,
                   preci, NoDimensD, med, Rc, cdistri);
      if ClaseDistrito then
        ShowEstimClaseH(fout, gout, NoItms, NoRegIni, iiPolar,nnPolar,
             preci, NoDimensD, med, Rc, cdistri);
    end;


End;

{
procedure iniTitleDimenH(var fout: text; IndiNivel: byte);
  var nombNiv: TnombreFi;
Begin
   Ttulo para el clculo de dimensiones de partidos y desproporcionalidad 
  writeln(fout);
  tomaNombreNivel(nombNiv, IndiNivel);

  writeln(fout, '<h2>Indices of Disproportionality & Dimensions in<br>');
  write(fout, 'the aggregation level ');
  writeln(fout, nombNiv);
  writeln(fout, '</h2>');
End;
}

procedure ShowNiveleConH(var fout: text; IndiNive: byte;
                        var camino: TcaminFi);

{
This is a version of the procedure ShowNiveles which also shows the acronyms
of political parties.  

Este procedimiento es una versin del procedimiento ShowNiveles,
al cul se le ha aadido la visualizacin de las siglas de partidos. }

  const  MaxSiglasP = 5;

  var nomNive: TnombreFi;
      fnivel: TfichNivel;
      i, noNiv: TItmsNivel;
      acEsca, acVoto: Tnumero;
      rniv: TRegNivel;
      gPou: TfichParty;
      PaO: Tparty;
      j, noParti: TRgPartido;

Begin
  tomaNombreNivel(nomNive, IndiNive);
  assign(fnivel, camino+nomNive+'.cg');
  reset(fnivel);

  read(fnivel, rniv);
  noNiv:= rniv.tamano;

  acEsca:= 0;   acVoto:= 0;

  NombraFichPartyD(gPou, camino, IndiNive);
  reset(gPou);

  writeln(fout);
  write(fout, '<h3>List of the items of the aggregation level ');
  writeln(fout, nomNive);
  writeln(fout, 'and some of the most voted parties:</h3>');

  writeln(fout, '<p> <table cellspacing="5" border="1"> <tr>');

  writeHeadTabla(fout, 'Items', 'l');
  writeHeadTabla(fout, 'Votes', 'r');
  writeHeadTabla(fout, 'Seats', 'r');

  for i:= 1 to MaxSiglasP do
   begin
     write(fout, '<td align="right">');
     write(fout, i);
     writeln(fout, '</td>');
   end;

  writeln(fout, '</tr>');


  for i:= 0 to noNiv do
    begin
      read(fnivel, rniv);

      writeln(fout, '<tr>');
      writeItmTabla(fout, rniv.NomNivel, 'l');
      escridaEEHT(fout, rniv.votos,  0);
      escridaEEHT(fout, rniv.tamano, 0);

      acVoto:= acVoto + rniv.votos;
      acEsca:= acEsca + rniv.tamano;

      read(gPou, PaO);
      noParti:= trunc(PaO.Ep);

      for j:=0 to noParti do
        begin
         read(gPou, PaO);

         if j < MaxSiglasP then
          writeItmTabla(fout, PaO.SiglasCandi, 'r');
        end;

      writeln(fout, '</tr>');
    end;

  close(gPou);

  writeln(fout, '<tr>');
  writeItmTabla(fout, 'SUM', 'c');
  escridaEEHT(fout, acVoto,  0);
  escridaEEHT(fout, acEsca,  0);

  for j:=1 to MaxSiglasP do write(fout, '<td> </td>');

  writeln(fout, '</tr>');
  writeln(fout, '</table> </p>');

  close(fnivel);
  flush(fout);
End;
{ *********************************************************   }



procedure ShowDimenH(var camino: TcaminFi; var fout: text;
                     NoNiveleUt, IndNivelMx: byte);

  var IndiNivel: byte;
      gout: Tfichero;

Begin
  for IndiNivel:= IndNivelMx to NoNiveleUt do
    begin
      MarcaFrameMenuI(camino, IndiNivel, 'mD');

      introMarcaHTML(fout, IndiNivel, 'mD');


      iniTitleDimen(fout, IndiNivel, 'h');

      ShowNiveleConH(fout, IndiNivel, camino);

      NombraFichDim(gout, camino, IndiNivel);
      reset(gout);

      ShowMedidaH(fout, gout, (IndiNivel = NoNiveleUt)); {IndiNivel > 1}

      close(gout);
    end;
End;


procedure iniTituRegiH(var fout: text; var gout: Tfichero;
                      var vNivAmbSup: TRegNivel;
                      IndiAmbSup, IndiAmbInf: byte);

  var nomb: TnombreFi;     
      r: Tnumero;
Begin
  writeln(fout);
  ShowSignifica('regiona', 'h', fout);

{ Inicio: escritura de una marca HTML }

  writeln(fout, '<p><h2>Electoral regionalism</h2></p>');

  writeln(fout, '<p><table cellspacing="10">');
  writeln(fout, '<tr>');
  writeHeadTabla(fout, 'Upper aggregation level : ', 'r');
  tomaNombreNivel(nomb, IndiAmbSup);
  writeItmTabla(fout, nomb, 'l');
  writeln(fout, '</tr> <tr>');

  writeHeadTabla(fout, 'Upper level item : ', 'r');
  writeItmTabla(fout, vNivAmbSup.NomNivel, 'l');
  writeln(fout, '</tr> <tr>');

  writeln(fout, '</tr> <tr>');

  writeHeadTabla(fout, 'Lower aggregation level : ', 'r');
  tomaNombreNivel(nomb, IndiAmbInf);
  writeItmTabla(fout, nomb, 'l');
  writeln(fout, '</tr></table> </p>');

  seek(gout, 1);  read(gout, r);

  writeln(fout, '<p>');
{ Total voto PANE en mbito superior }  
  writeln(fout, '<b>Total (PANE) regionalist vote at the upper level item = </b>');  
  escridat(fout, r, 0, preci, FALSE, TRUE); {escridaEEHT(fout, r, preci);}
  writeln(fout, '</p>');

  writeln(fout, '<p><table cellspacing="10"> <tr>');
  writeln(fout, '<th> </th>');
  writeHeadTabla(fout, 'VRta', 'r');
  writeHeadTabla(fout, 'VRtaD', 'r');
  writeHeadTabla(fout, 'VRDe', 'r');
  writeHeadTabla(fout, 'VRD', 'r');
  writeln(fout, '</tr>');
End;


procedure iniTituLinkageH(var fout: text; var gout: Tfichero;
                      var vNivAmbSup: TRegNivel;
                      IndiAmbSup, IndiAmbInf: byte);

  var nomb: TnombreFi;     
      r, totENP, ENPavg, ENPw: Tnumero;
Begin
  writeln(fout);
  ShowSignifica('linkage', 'h', fout);

{ Inicio: escritura de una marca HTML }


  writeln(fout, '<p><h2>Party linkage</h2></p>');

  writeln(fout, '<p><table cellspacing="10">');
  writeln(fout, '<tr>');
  writeHeadTabla(fout, 'Upper aggregation level : ', 'r');
  tomaNombreNivel(nomb, IndiAmbSup);
  writeItmTabla(fout, nomb, 'l');
  writeln(fout, '</tr> <tr>');

  writeHeadTabla(fout, 'Upper level item : ', 'r');
  writeItmTabla(fout, vNivAmbSup.NomNivel, 'l');
  writeln(fout, '</tr> <tr>');

  writeln(fout, '</tr> <tr>');

  writeHeadTabla(fout, 'Lower aggregation level : ', 'r');
  tomaNombreNivel(nomb, IndiAmbInf);
  writeItmTabla(fout, nomb, 'l');
  writeln(fout, '</tr></table> </p>');

  seek(gout, 2);  
  read(gout, totENP);

  writeln(fout, '<p>');
  write(fout, '<b>ENP at the upper level item = </b> ');
  escridat(fout, totENP, 0, preci, FALSE, TRUE); {escridaEEHT(fout, totENP, preci);}
 

  writeln(fout, '</p> <p>');
  read(gout, ENPavg);  
  write(fout, '<b>Average ENP in the lower aggregation level = </b> ');
  escridat(fout, ENPavg, 0, preci, FALSE, TRUE); {escridaEEHT(fout, ENPavg, preci);}
  writeln(fout, '<br>');

  write(fout, '<b>Cox inflation rate(%) = </b>');
  r:= inflationCox(totENP, ENPavg);
  escridat(fout, r, 0, preci, FALSE, TRUE); {escridaEEHT(fout, r, preci);}
  writeln(fout, '<br>');

  write(fout, '<b>Moenius & Kasuya inflation rate(%) = </b>');
  r:= inflationMoKa(totENP, ENPavg);
  escridat(fout, r, 0, preci, FALSE, TRUE); {escridaEEHT(fout, r, preci);}
  writeln(fout, '</p> <p>');

  read(gout, ENPw);
  write(fout, '<b>Weighted average ENP in the lower aggregation level = </b> ');
  escridat(fout, ENPw, 0, preci, FALSE, TRUE); {escridaEEHT(fout, ENPw, preci);}
  writeln(fout, '<br>');

  write(fout, '<b>Cox weighted inflation rate(%) = </b>');
  r:= inflationCox(totENP, ENPw);
  escridat(fout, r, 0, preci, FALSE, TRUE); {escridaEEHT(fout, r, preci);}
  writeln(fout, '<br>');

  write(fout, '<b>Moenius & Kasuya weighted inflation rate(%) = </b>');
  r:= inflationMoKa(totENP, ENPw);
  escridat(fout, r, 0, preci, FALSE, TRUE); {escridaEEHT(fout, r, preci);}
  writeln(fout, '</p>'); 


  writeln(fout, '<p><table cellspacing="10"> <tr>');
  writeln(fout, '<th> </th>');
  writeHeadTabla(fout, 'ENP', 'r');
  writeHeadTabla(fout, 'CKr', 'r');
  writeHeadTabla(fout, 'Coxr', 'r');
  writeHeadTabla(fout, 'MKr', 'r');
  writeln(fout, '</tr>');
End;
{ ******************************************************* }

procedure ShowRegionH(var fout: text; var camino: TcaminFi;
                     IndAmbSup, IndAmbInf: byte;
                     ClaseDistrito: boolean);

  label otro;

  const NoRegIni = EqNo + 1 + nnRegi0Fi;
        NoDimensD = EqNo+1+NNindxFichReg; { = EqNo + 1 + 4}

  var gout: Tfichero;
      vNivAmbSup: TRegNivel;
      NoItmsAI, iItmAS: TItmsNivel;
      med: PVector;
      Rc: PMatrix;


Begin
  iItmAS:= 0;

  while GetItm(camino, vNivAmbSup, IndAmbSup, iItmAS) do
    begin
      NombraFichReg(gout, camino, IndAmbSup, IndAmbInf, vNivAmbSup, 'reg');
       {$I-}
      reset(gout);
       {$I+}

      if IoResult <> 0 then goto otro;

      introMarcaRegiHTML(camino, fout, vNivAmbSup, IndAmbSup, IndAmbInf);

      iniTituRegiH(fout, gout, vNivAmbSup, IndAmbSup, IndAmbInf);
      ShowMedidaxH(fout, gout, NoItmsAI, NoRegIni, iiRegi, nnRegi, preci,
                    NoDimensD);
      if NoItmsAI = 0
      then
           writeln(fout, '</table></p>')
      else
         begin
           ShowEstimasH(fout, gout, NoItmsAI, NoRegIni, iiRegi, nnRegi,
                        preci, NoDimensD, med, Rc, cdistri);
           if ClaseDistrito then
             ShowEstimClaseH(fout, gout, NoItmsAI, NoRegIni, iiRegi, nnRegi,
                              preci, NoDimensD, med, Rc, cdistri);
         end;


      iniTituLinkageH(fout, gout, vNivAmbSup, IndAmbSup, IndAmbInf);
      ShowMedidaxH(fout, gout, NoItmsAI, NoRegIni, iiENP, nnENP, preci,
                    NoDimensD);
      if NoItmsAI = 0
      then
           writeln(fout, '</table></p>')
      else
         begin
           ShowEstimasH(fout, gout, NoItmsAI, NoRegIni, iiENP, nnENP,
                        preci, NoDimensD, med, Rc, 1);
           if ClaseDistrito then
             ShowEstimClaseH(fout, gout, NoItmsAI, NoRegIni, iiENP, nnENP,
                              preci, NoDimensD, med, Rc, 1);
         end;


      close(gout);

      otro:
      Inc(iItmAS);
    end;
End;

procedure ShowRegionalH(var fout: text; var camino: TcaminFi;
                        NoNiveleUt, IndNivelMx: byte);

  var IndAmbSup, IndAmbInf: byte;

Begin
  contiFrameMenuDi(camino);

  for IndAmbSup:= IndNivelMx to NoNiveleUt do
   for IndAmbInf:= Succ(IndAmbSup) to NoNiveleUt do
    ShowRegionH(fout, camino, IndAmbSup, IndAmbInf,
             (IndAmbSup=0) and (IndAmbInf= NoNiveleUt));
End;


procedure iniDimensiOutHTML(var fout: text; var camino: TcaminFi);
begin
  writeln(fout, '<html>');
  writeln(fout, '<head>');

  IntroMetaHTML(fout);

  writeln(fout, '<title>');
  showTitulo(camino, fout, 'h');
  writeln(fout, '</title>');

  writeln(fout, '</head>');
  writeln(fout, '<body>');

  MmbrIndxNiv(fout, 0, 'h');

  writeln(fout, '<p><h3>');
  write(fout, camino);
  writeln(fout, '</h3> </p>');
end;


procedure finDimensiOutHTML(var fout: text);
begin
  writeln(fout, '</body>');
  writeln(fout, '</html>');
end;


procedure ShowFiHTML(var camino: TcaminFi;
                     NoNiveleUti, IndNivelAgrMx: byte);
  var fout: text;
Begin
{ fichero HTML que gestiona los frames }
  DoFramePrincipal(camino);

{ Inicia la creacin del fichero HTML que contiene el menu para la
 estructura de frames para el mdulo Dimensi. }
  iniFrameMenuDi(camino);

{ fichero HTML con contenido principal }
  assign(fout, camino+'result.htm');   rewrite(fout);

  iniDimensiOutHTML(fout, camino);

  ShowDimenH(camino, fout, NoNiveleUti, IndNivelAgrMx);

  ShowRegionalH(fout, camino, NoNiveleUti, IndNivelAgrMx);

  close(fout);

  finFrameMenuDi(camino);

End;




End.
