{ =====================================================
 Copyright (C) 2007 Francisco A. Ocana & Pablo Onate 

 This file is part of IndElec

 IndElec is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 IndElec is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You have received a copy of the GNU General Public License
 in a file called COPYING which you should have received with
 IndElec. If not, see <http://www.gnu.org/licenses/>.
 ===================================================== 
}
unit DIMINOUN;

{
Create the text file with report style from the output of
the module Dimensi with data aggregation levels.
}

INTERFACE

uses COMUN;

procedure ShowFiTXT(var camino: TcaminFi;
                   NoNiveleUti,IndNivelAgrMx: byte);


IMPLEMENTATION

uses DEFNIVEL, COMUTIL, DIMSIGLA, DIMDEFN,
     DIMVECTO, DIMAUXN,
     DIMENSIU, DIMREG, DIMESTIM, UINPOUT,MEMBRETE, CABECERA;


const tabu = 7;
      preci = 2;
      





procedure ShowSesgo(var fout: text; var gout: Tfichero;
            var NoItms: TItmsNivel;  NoRegIniFich: word;
            tabu, preci, NoDimenss: byte);

{
   NoRegIniFich = Nmero de registros iniciales del fichero,
           tabu = amplitud tabulador,
          preci = precisin,
      NoDimenss = nmero total de registros por items,
}

  var b, r2: Tnumero;
      j: TItmsNivel;
      rniv: TRegNivel;
      i: byte;
      posIni: word;

 procedure pendiRobu(ponR2: boolean);
 Begin
    read(gout, b, r2);

    if r2 > 0
    then
      begin
        escridat(fout, b, tabu, preci, TRUE, FALSE);
        if ponR2 then escridat(fout, r2, tabu, preci, TRUE, FALSE);
      end
    else
      begin
        write(fout, ' ': tabu);  write(fout, charTabu);
        if ponR2 then
          begin
            write(fout, ' ': tabu);   write(fout, charTabu);
          end;
      end;
 End;


Begin
  reset(gout);

  read(gout, r2);    NoItms:= Trunc(r2);

  posIni:= NoRegIniFich + EqNo + iiSesg; 
           {NoRegIniFich + EqNo + 16;}

  for j:= 0 to NoItms do
    begin
      seek(gout, NoRegIniFich);
      ReadNivel(gout, rniv);

      write(fout, rniv.NomNivel: lenCadItmNiv);   write(fout, charTabu);

      seek(gout, posIni);

      for i:= 1 to nnSesgLS do pendiRobu(TRUE);

      for i:= 1 to nnSesgTuk do pendiRobu(FALSE);

      writeln(fout);

      Inc(posIni, NoDimenss);
      Inc(NoRegIniFich, NoDimenss);
    end;

  flush(fout);
End;
{ *************************************************************}

procedure escrituraSesg(var fout: text;
                        var gy: Tfichero; posi: word);

const nnSesg1 = nnSesg - 1; { 6 }

  procedure saltito;
  begin
    write(fout, ' ':tabu);
    write(fout, charTabu);
  end;

  var j: byte;
      rx: Tnumero;
      crx: char absolute rx;      

Begin
  for j:= 0 to nnSesg1 do
    begin
      seek(gy, posi);
      read(gy, rx);
      
      if crx = '*'
      then
        saltito
      else
        escridat(fout, rx, tabu, preci, TRUE, FALSE);

      if j < nnSesgLS then saltito;
   
      Inc(posi, 5);
    end;

  writeln(fout);
End;


procedure ShowEstima1Sesgo(var fout: text);
  var gy: Tfichero;

Begin
  assign(gy, camIndElec+'datum.aux');  reset(gy);

  writeln(fout);

  write(fout, ' Min':lenCadItmNiv);  write(fout, charTabu);
  escrituraSesg(fout, gy, 0);

  write(fout, 'Q1': lenCadItmNiv);  write(fout, charTabu);
  escrituraSesg(fout, gy, 1);

  write(fout, 'Me': lenCadItmNiv);   write(fout, charTabu);
  escrituraSesg(fout, gy, 2);

  write(fout, 'Q3': lenCadItmNiv);    write(fout, charTabu);
  escrituraSesg(fout, gy, 3);

  write(fout, 'Max': lenCadItmNiv);  write(fout, charTabu);
  escrituraSesg(fout, gy, 4);

  close(gy);
  flush(fout);
End;
{ **************************************************************** }


procedure ShowMedidas(var fout: text; var gout: Tfichero;
                      ClaseDistrito: boolean);

  const NoRegIni = 2;
        NoDimensD = EqNo + 1 + NNIndexs ; { = EqNo + 49 }
       



  var NoItms: TItmsNivel;
      med: PVector;
      Rc: PMatrix;

Begin
  ShowSignifica('despropo', 'b', fout);
  cabeDespro(fout);
  ShowMedidax(fout,gout,NoItms,NoRegIni,iiDspro,nnDspro,tabu,preci,NoDimensD);
  if NoItms > 0 then
    begin
      ShowEstimas(fout, gout, NoItms, NoRegIni, iiDspro, nnDspro,
                  tabu, preci, NoDimensD, med, Rc, cdistri);
      if ClaseDistrito then
        ShowEstimaClase(fout, gout, NoItms, NoRegIni, iiDspro, nnDspro,
                     tabu, preci, NoDimensD, med, Rc, cdistri);
    end;

  ShowSignifica('DespRobu', 'b', fout);
  cabeDesproRobu(fout);
  ShowMedidax(fout, gout, NoItms, NoRegIni, iiDsRobu, nnDsRobu, tabu, preci, NoDimensD);
  if NoItms > 0 then
    begin
      ShowEstimas(fout, gout, NoItms, NoRegIni, iiDsRobu, nnDsRobu,
                     tabu, preci, NoDimensD, med, Rc, cdistri);
      if ClaseDistrito then
        ShowEstimaClase(fout, gout, NoItms, NoRegIni, iiDsRobu, nnDsRobu,
                     tabu, preci, NoDimensD, med, Rc, cdistri);

    end;


  ShowSignifica('sesgos', 'b', fout);
  cabeSesgo(fout);
  ShowSesgo(fout, gout, NoItms, NoRegIni, tabu, preci, NoDimensD);
  if NoItms > 0 then
    begin
      IniEstimaxSesgo(gout, NoItms, NoRegIni, NoDimensD);
      Estimar1(nnsesg);
      ShowEstima1Sesgo(fout);
    end;


  ShowSignifica('fragCCcm', 'b', fout);
  cabeFragConceCompe(fout);
  ShowMedidax(fout, gout, NoItms, NoRegIni, iiFrgCCcm, nnFrgCCcm, tabu, preci,
              NoDimensD);
  if NoItms > 0 then
    begin
      ShowEstimas(fout, gout, NoItms, NoRegIni, iiFrgCCcm,nnFrgCCcm,
                  tabu, preci, NoDimensD, med, Rc, cdistri);
      if ClaseDistrito then
        ShowEstimaClase(fout, gout, NoItms, NoRegIni, iiFrgCCcm,nnFrgCCcm,
                     tabu, preci, NoDimensD, med, Rc, cdistri);

    end;


  ShowSignifica('noEfecti', 'b', fout);
  cabeNoEfect(fout);
  ShowMedidax(fout, gout, NoItms, NoRegIni, iiNoEff, nnNoEff, tabu, preci,
              NoDimensD);
  if NoItms > 0 then
    begin
      ShowEstimas(fout, gout, NoItms, NoRegIni, iiNoEff, nnNoEff,
                  tabu, preci, NoDimensD, med, Rc, cdistri);
      if ClaseDistrito then
        ShowEstimaClase(fout, gout, NoItms, NoRegIni, iiNoEff, nnNoEff,
                     tabu, preci, NoDimensD, med, Rc, cdistri);

    end;


  ShowSignifica('polariza', 'b', fout);
  cabePolari(fout);
  ShowMedidax(fout, gout, NoItms, NoRegIni, iiPolar, nnPolar, tabu, preci,
              NoDimensD);
  if NoItms > 0 then
    begin
      ShowEstimas(fout, gout, NoItms, NoRegIni, iiPolar, nnPolar,
                  tabu, preci, NoDimensD, med, Rc, cdistri);
      if ClaseDistrito then
        ShowEstimaClase(fout, gout, NoItms, NoRegIni, iiPolar, nnPolar,
                     tabu, preci, NoDimensD, med, Rc, cdistri);

    end;


End;


procedure ShowNiveleCon(var fout: text; IndiNive: byte; var camino: TcaminFi);

{  
This is a version of the procedure ShowNiveles which also shows the acronyms
of political parties.

Este procedimiento es una versin del procedimiento ShowNiveles,
al cul se le ha aadido la visualizacin de las siglas de partidos. }

  const tabVot = 13;
        tabEsc = 9;
        MaxSiglasP = 5;

  var nomNive: TnombreFi;
      fnivel: TfichNivel;
      i, noNiv: TItmsNivel;
      acEsca, acVoto: Tnumero;
      rniv: TRegNivel;
      gPou: TfichParty;
      PaO: Tparty;
      j, noParti: TRgPartido;

Begin
  tomaNombreNivel(nomNive, IndiNive);
  assign(fnivel, camino+nomNive+'.cg');
  reset(fnivel);

  read(fnivel, rniv);
  noNiv:= rniv.tamano;

  writeln(fout);
  write(fout, ' List of the items of the aggregation level ');
  writeln(fout, nomNive);
  writeln(fout, 'and some of the most voted parties:');
  

  writeln(fout);
  write(fout, 'Items ': lenCadItmNiv);    write(fout, charTabu);
  write(fout, 'Votes': tabVot);          write(fout, charTabu);
  write(fout, 'Seats': tabEsc);        write(fout, charTabu);

  for i:= 1 to MaxSiglasP do 
    begin
      write(fout, i:Succ(lenCandida));      write(fout, charTabu);
    end;

  writeln(fout);

  write(fout, '************':lenCadItmNiv);  write(fout, charTabu);
  write(fout, '*******':tabVot);             write(fout, charTabu);
  write(fout, '******':tabEsc);              write(fout, charTabu);

  for i:= 1 to MaxSiglasP do 
    begin
      write(fout, '******':Succ(lenCandida));
      write(fout, charTabu);
    end;

  writeln(fout);

  acEsca:= 0;   acVoto:= 0;

  NombraFichPartyD(gPou, camino, IndiNive);
  reset(gPou);

  for i:= 0 to noNiv do
    begin
      read(fnivel, rniv);

      write(fout, rniv.NomNivel:lenCadItmNiv);       write(fout, charTabu);
      escridatEE(fout, rniv.votos, tabVot, 0, TRUE, FALSE);
      escridatEE(fout, rniv.tamano, tabEsc, 0, TRUE, FALSE);

      acVoto:= acVoto + rniv.votos;
      acEsca:= acEsca + rniv.tamano;

      read(gPou, PaO);
      noParti:= trunc(PaO.Ep);

      for j:=0 to noParti do
        begin
         read(gPou, PaO);

         if j < MaxSiglasP then
            begin
             write(fout, PaO.SiglasCandi:Succ(lenCandida));
             write(fout, charTabu); 
            end;
        end;
 
      writeln(fout);
    end;

  close(gPou);
  close(fnivel);

  writeln(fout);
  write(fout, 'SUM':lenCadItmNiv);        write(fout, charTabu);
  escridatEE(fout, acVoto, tabVot, 0, TRUE, FALSE);
  escridatEE(fout, acEsca, tabEsc, 0, TRUE, TRUE);
  writeln(fout);
  writeln(fout);

  
  flush(fout);
End;
{ *********************************************************   }



procedure ShowDimen(var camino: TcaminFi; var fout: text;
                    NoNiveleUt, IndNivelMx: byte);

  var IndiNivel: byte;
      gout: Tfichero;

Begin
  for IndiNivel:= IndNivelMx to NoNiveleUt do
    begin
      iniTitleDimen(fout, IndiNivel, 't');

      ShowNiveleCon(fout, IndiNivel, camino);

      NombraFichDim(gout, camino, IndiNivel);
      reset(gout);

      ShowMedidas(fout, gout, (IndiNivel = NoNiveleUt));  {IndiNivel > 1}

      close(gout);
    end;
End;


procedure iniTituRegi(var fout: text; var gout: Tfichero;
                      var vNivAmbSup: TRegNivel;
                      IndiAmbSup, IndiAmbInf: byte);

  var nomb: TnombreFi;
      r: Tnumero;
Begin
  writeln(fout);
  ShowSignifica('regiona', 'b', fout);
  writeln(fout);
  writeln(fout, 'ELECTORAL REGIONALISM':45);
  writeln(fout);
  write(fout, 'Upper aggregation level : ':25);
  tomaNombreNivel(nomb, IndiAmbSup);
  writeln(fout, nomb);

  write(fout, 'Upper level item : ':25);
  writeln(fout, vNivAmbSup.NomNivel);

  writeln(fout);

  write(fout, 'Lower aggregation level : ':25);
  tomaNombreNivel(nomb, IndiAmbInf);
  writeln(fout, nomb);

  seek(gout, 1);  read(gout, r);

  writeln(fout);
  { Regionalist vote at the upper level item }
  write(fout, 'Total (PANE) regionalist vote at the upper level item = ');  
  escridat(fout, r, 0, preci, TRUE, TRUE);
  writeln(fout);

  write(fout, ' ': lenCadItmNiv);     write(fout, charTabu);
  write(fout, 'VRta': tabu);      write(fout, charTabu);
  write(fout, 'VRtaD': tabu);   write(fout, charTabu);
  write(fout, 'VRDe': tabu);    write(fout, charTabu);
  write(fout, 'VRD': tabu);     writeln(fout, charTabu);
End;


procedure iniTituLinkage(var fout: text; var gout: Tfichero;
                      var vNivAmbSup: TRegNivel;
                      IndiAmbSup, IndiAmbInf: byte);

  var nomb: TnombreFi;
      r, totENP, ENPavg, ENPw: Tnumero;
Begin
  writeln(fout);
  ShowSignifica('linkage', 'b', fout);
  writeln(fout);
  writeln(fout, 'PARTY LINKAGE':35);
  writeln(fout);
  write(fout, 'Upper aggregation level : ':25);
  tomaNombreNivel(nomb, IndiAmbSup);
  writeln(fout, nomb);

  write(fout, 'Upper level item : ':25);
  writeln(fout, vNivAmbSup.NomNivel);

  writeln(fout);

  write(fout, 'Lower aggregation level : ':25);
  tomaNombreNivel(nomb, IndiAmbInf);
  writeln(fout, nomb);

  seek(gout, 2);  

  read(gout, totENP);  
  writeln(fout);
  write(fout, 'ENP at the upper level item = ');  
  escridat(fout, totENP, 0, preci, TRUE, TRUE);
  writeln(fout);

  read(gout, ENPavg);  
  writeln(fout);
  write(fout, 'Average ENP in the lower aggregation level = ');
  escridat(fout, ENPavg, 0, preci, TRUE, TRUE);
 
  write(fout, 'Cox inflation rate(%) = ');
  r:= inflationCox(totENP, ENPavg);
  escridat(fout, r, 0, preci, TRUE, TRUE);

  write(fout, 'Moenius & Kasuya inflation rate(%) = ');
  r:= inflationMoKa(totENP, ENPavg);
  escridat(fout, r, 0, preci, TRUE, TRUE);
  writeln(fout);

  read(gout, ENPw);  
  writeln(fout);
  write(fout, 'Weighted average ENP in the lower aggregation level = ');
  escridat(fout, ENPw, 0, preci, TRUE, TRUE);

  write(fout, 'Cox weighted inflation rate(%) = ');
  r:= inflationCox(totENP, ENPw);
  escridat(fout, r, 0, preci, TRUE, TRUE);

  write(fout, 'Moenius & Kasuya weighted inflation rate(%) = ');
  r:= inflationMoKa(totENP, ENPw);
  escridat(fout, r, 0, preci, TRUE, TRUE);
  writeln(fout);

  write(fout, ' ': lenCadItmNiv); write(fout, charTabu);
  write(fout, 'ENP': tabu);       write(fout, charTabu);
  write(fout, 'CKr': tabu);       write(fout, charTabu);
  write(fout, 'Coxr': tabu);      write(fout, charTabu);
  write(fout, 'MKr': tabu);       writeln(fout, charTabu);
End;



procedure ShowRegion(var fout: text; var camino: TcaminFi;
                     IndAmbSup, IndAmbInf: byte;
                     ClaseDistrito: boolean);

  label otro;

  const NoRegIni = EqNo + 1 + nnRegi0Fi;  { = EqNo + 1 + 8}
        NoDimensD = EqNo + 1 + NNindxFichReg; { = EqNo + 1 + 8}
        

  var gout: Tfichero;
      vNivAmbSup: TRegNivel;
      NoItmsAI, iItmAS: TItmsNivel;
      med: PVector;
      Rc: PMatrix;


Begin
  iItmAS:= 0;

  while GetItm(camino, vNivAmbSup, IndAmbSup, iItmAS) do
    begin
      NombraFichReg(gout, camino, IndAmbSup, IndAmbInf, vNivAmbSup, 'reg');
      {$I-}
      reset(gout);
      {$I+}

      if IoResult <> 0 then goto otro;


      iniTituRegi(fout, gout, vNivAmbSup, IndAmbSup, IndAmbInf);
      ShowMedidax(fout, gout, NoItmsAI, NoRegIni, iiRegi, nnRegi, tabu, preci,
                   NoDimensD);
      if NoItmsAI > 0 then
        begin
          ShowEstimas(fout, gout, NoItmsAI, NoRegIni, iiRegi, nnRegi,
                      tabu, preci, NoDimensD, med, Rc, cdistri);
          if ClaseDistrito then
             ShowEstimaClase(fout, gout, NoItmsAI, NoRegIni, iiRegi, nnRegi,
                             tabu, preci, NoDimensD, med, Rc, cdistri);
        end;


      iniTituLinkage(fout, gout, vNivAmbSup, IndAmbSup, IndAmbInf);
      ShowMedidax(fout, gout, NoItmsAI, NoRegIni, iiENP, nnENP, tabu, preci,
                   NoDimensD);
      if NoItmsAI > 0 then
        begin
          ShowEstimas(fout, gout, NoItmsAI, NoRegIni, iiENP, nnENP,
                      tabu, preci, NoDimensD, med, Rc, 1);
          if ClaseDistrito then
             ShowEstimaClase(fout, gout, NoItmsAI, NoRegIni, iiENP, nnENP,
                             tabu, preci, NoDimensD, med, Rc, 1);
        end;


      close(gout);

      otro:
      Inc(iItmAS);
    end;
End;

procedure ShowRegional(var fout: text; var camino: TcaminFi;
                       NoNiveleUt, IndNivelMx: byte);

  var IndAmbSup, IndAmbInf: byte;

Begin
  for IndAmbSup:= IndNivelMx to NoNiveleUt do
   for IndAmbInf:= Succ(IndAmbSup) to NoNiveleUt do
    ShowRegion(fout, camino, IndAmbSup, IndAmbInf,
             (IndAmbSup=0) and (IndAmbInf= NoNiveleUt));
End;


procedure ShowFiTXT(var camino: TcaminFi;
                    NoNiveleUti, IndNivelAgrMx: byte);
  var fout: text;
Begin
  assign(fout, camino+'result.out');   rewrite(fout);

  MmbrIndxNiv(fout, 0, 't');
  showTitulo(camino, fout, 't');
  ShowDimen(camino, fout, NoNiveleUti, IndNivelAgrMx);

  ShowRegional(fout, camino, NoNiveleUti, IndNivelAgrMx);
  close(fout);
End;


{ The End of dimInOuN }
END.
