{ =====================================================
 Copyright (C) 2007 Francisco A. Ocana & Pablo Onate 

 This file is part of IndElec

 IndElec is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 IndElec is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You have received a copy of the GNU General Public License
 in a file called COPYING which you should have received with
 IndElec. If not, see <http://www.gnu.org/licenses/>.
 ===================================================== 
}
unit DIMINOUS;

{ 
Create the CSV file with report style from the output of
the module Dimensi with data aggregation levels.

CSV version of dimInOuN
}

INTERFACE

uses COMUN;

procedure ShowFiCSV(var camino: TcaminFi; NoNiveleUti,IndNivelAgrMx: byte);


IMPLEMENTATION

uses DEFNIVEL, COMUTIL, DIMSIGLA, DIMDEFN, DIMVECTO, DIMAUXN,
     DIMENSIU, DIMREG, DIMESTIM, UINPOUT, MEMBRETE, CABECERA;



procedure ShowSesgoCSV(var fout: text; var gout: Tfichero; var NoItms: TItmsNivel;
                 NoRegIniFich: word; NoDimenss: byte);

{
   NoRegIniFich = Nmero de registros iniciales del fichero,
       
   NoDimenss = nmero total de registros por items,
}

  var b, r2: Tnumero;
      j: TItmsNivel;
      rniv: TRegNivel;
      i: byte;
      posIni: word;

 procedure pendiRobu(ponR2: boolean);
 Begin
    read(gout, b, r2);

    if r2 > 0
    then
      begin
        escridatCSV(fout, b, FALSE);
        if ponR2 then escridatCSV(fout, r2, FALSE);
      end
    else
      begin
        write(fout, sepacsv);
        if ponR2 then write(fout, sepacsv);
         
      end;
 End;


Begin
  reset(gout);

  read(gout, r2);    NoItms:= Trunc(r2);

  posIni:= NoRegIniFich + EqNo + + iiSesg; 
           {NoRegIniFich + EqNo + 16;}

  for j:= 0 to NoItms do
    begin
      seek(gout, NoRegIniFich);
      ReadNivel(gout, rniv);

      write(fout, rniv.NomNivel);

      seek(gout, posIni);

      for i:= 1 to nnSesgLS do pendiRobu(TRUE);

      for i:= 1 to nnSesgTuk do pendiRobu(FALSE);

      writeln(fout);

      Inc(posIni, NoDimenss);
      Inc(NoRegIniFich, NoDimenss);
    end;

  flush(fout);
End;
{ *************************************************************}

procedure escrituraSesgCSV(var fout: text;
                          var gy: Tfichero; posi: word);

  const nnSesg1 = nnSesg - 1; { 6 }

  var j: byte;
      rx: Tnumero;
      crx: char absolute rx;

Begin
  for j:= 0 to nnSesg1 do
    begin
      seek(gy, posi);
      read(gy, rx);

      if crx = '*'
      then
         write(fout, sepacsv)
      else
         escridatCSV(fout, rx, FALSE);
   
      if j < nnSesgLS then write(fout, sepacsv);
       
      Inc(posi, 5);
    end;

  writeln(fout);
End;


procedure ShowEstima1SesgoCSV(var fout: text);
  var gy: Tfichero;

Begin
  assign(gy, camIndElec+'datum.aux');  reset(gy);

  writeln(fout);

  write(fout, ' Min');
  escrituraSesgCSV(fout, gy, 0);

  write(fout, 'Q1');
  escrituraSesgCSV(fout, gy, 1);

  write(fout, 'Me');
  escrituraSesgCSV(fout, gy, 2);

  write(fout, 'Q3');
  escrituraSesgCSV(fout, gy, 3);

  write(fout, 'Max');  
  escrituraSesgCSV(fout, gy, 4);

  close(gy);
  flush(fout);
End;
{ **************************************************************** }


procedure ShowMedidasCSV(var fout: text; var gout: Tfichero;
                      ClaseDistrito: boolean);

  const NoRegIni = 2;
        NoDimensD = EqNo + 1 + NNIndexs ; { = EqNo + 49 }


    

  var NoItms: TItmsNivel;
      med: PVector;
      Rc: PMatrix;

Begin
  ShowSignifica('despropo', 'c', fout);
  cabeDesproCSV(fout);
  ShowMedidaxCSV(fout, gout, NoItms, NoRegIni, iiDspro, nnDspro, NoDimensD);
  if NoItms > 0 then
    begin
      ShowEstimasCSV(fout, gout, NoItms, NoRegIni, iiDspro, nnDspro,
                      NoDimensD, med, Rc, cdistri);
      if ClaseDistrito then
        ShowEstimaClaseCSV(fout, gout, NoItms, NoRegIni, iiDspro, nnDspro,
                      NoDimensD, med, Rc, cdistri);
    end;

  ShowSignifica('DespRobu', 'c', fout);
  cabeDesproRobuCSV(fout);
  ShowMedidaxCSV(fout, gout, NoItms, NoRegIni, iiDsRobu, nnDsRobu,  NoDimensD);
  if NoItms > 0 then
    begin
      ShowEstimasCSV(fout, gout, NoItms, NoRegIni, iiDsRobu, nnDsRobu,
                     NoDimensD, med, Rc, cdistri);
      if ClaseDistrito then
        ShowEstimaClaseCSV(fout, gout, NoItms, NoRegIni, iiDsRobu, nnDsRobu,
                          NoDimensD, med, Rc, cdistri);

    end;


  ShowSignifica('sesgos', 'c', fout);
  cabeSesgoCSV(fout);
  ShowSesgoCSV(fout, gout, NoItms, NoRegIni, NoDimensD);
  if NoItms > 0 then
    begin
      IniEstimaxSesgo(gout, NoItms, NoRegIni, NoDimensD);
      Estimar1(nnsesg);
      ShowEstima1SesgoCSV(fout);
    end;


  ShowSignifica('fragCCcm', 'c', fout);
  cabeFragConceCompeCSV(fout);
  ShowMedidaxCSV(fout, gout, NoItms, NoRegIni, iiFrgCCcm, nnFrgCCcm, NoDimensD);
  if NoItms > 0 then
    begin
      ShowEstimasCSV(fout, gout, NoItms, NoRegIni, iiFrgCCcm,nnFrgCCcm,
                      NoDimensD, med, Rc, cdistri);
      if ClaseDistrito then
        ShowEstimaClaseCSV(fout, gout, NoItms, NoRegIni, iiFrgCCcm,nnFrgCCcm,
                      NoDimensD, med, Rc, cdistri);

    end;


  ShowSignifica('noEfecti', 'c', fout);
  cabeNoEfectCSV(fout);
  ShowMedidaxCSV(fout, gout, NoItms, NoRegIni, iiNoEff, nnNoEff, NoDimensD);
  if NoItms > 0 then
    begin
      ShowEstimasCSV(fout, gout, NoItms, NoRegIni, iiNoEff, nnNoEff,
                      NoDimensD, med, Rc, cdistri);
      if ClaseDistrito then
        ShowEstimaClaseCSV(fout, gout, NoItms, NoRegIni, iiNoEff, nnNoEff,
                      NoDimensD, med, Rc, cdistri);

    end;


  ShowSignifica('polariza', 'c', fout);
  cabePolariCSV(fout);
  ShowMedidaxCSV(fout, gout, NoItms, NoRegIni, iiPolar, nnPolar, NoDimensD);
  if NoItms > 0 then
    begin
      ShowEstimasCSV(fout, gout, NoItms, NoRegIni, iiPolar, nnPolar,
                      NoDimensD, med, Rc, cdistri);
      if ClaseDistrito then
        ShowEstimaClaseCSV(fout, gout, NoItms, NoRegIni, iiPolar, nnPolar,
                      NoDimensD, med, Rc, cdistri);

    end;


End;




procedure ShowNiveleConCSV(var fout: text;  IndiNive: byte;
                        var camino: TcaminFi);

{  
This is a version of the procedure ShowNiveles which also shows the acronyms
of political parties.

Este procedimiento es una versin del procedimiento ShowNiveles,
al cul se le ha aadido la visualizacin de las siglas de partidos. }

  const  MaxSiglasP = 5;

  var nomNive: TnombreFi;
      fnivel: TfichNivel;
      i, noNiv: TItmsNivel;
      acEsca, acVoto: Tnumero;
      rniv: TRegNivel;
      gPou: TfichParty;
      PaO: Tparty;
      j, noParti: TRgPartido;

Begin
  tomaNombreNivel(nomNive, IndiNive);
  assign(fnivel, camino+nomNive+'.cg');
  reset(fnivel);

  read(fnivel, rniv);
  noNiv:= rniv.tamano;

  writeln(fout);
  write(fout, '" List of the items of the aggregation level ');
  writeln(fout, nomNive, '"');
  writeln(fout, '"and some of the most voted parties:"');
  

  writeln(fout);
  write(fout, '"Items"', sepacsv);
  write(fout, '"Votes"', sepacsv);
  write(fout, '"Seats"');

  for i:= 1 to MaxSiglasP do 
    begin
      write(fout, sepacsv);
      write(fout, i);
    end;

  writeln(fout);

  acEsca:= 0;   acVoto:= 0;

  NombraFichPartyD(gPou, camino, IndiNive);
  reset(gPou);

  for i:= 0 to noNiv do
    begin
      read(fnivel, rniv);
      
      write(fout, '"', rniv.NomNivel, '"');    
      escridatEEcsv(fout, rniv.votos, FALSE);
      escridatEEcsv(fout, rniv.tamano, FALSE);

      acVoto:= acVoto + rniv.votos;
      acEsca:= acEsca + rniv.tamano;

      read(gPou, PaO);
      noParti:= trunc(PaO.Ep);

      for j:=0 to noParti do
        begin
         read(gPou, PaO);

         if j < MaxSiglasP then
            begin
             write(fout, sepacsv);
             write(fout, '"', PaO.SiglasCandi, '"');
            end;
        end;
 
      writeln(fout);
    end;

  close(gPou);

  writeln(fout);
  write(fout, '"SUM"');
  escridatEEcsv(fout, acVoto, FALSE);
  escridatEEcsv(fout, acEsca, FALSE);

  {for i:= 1 to MaxSiglasP do write(fout, sepacsv); }

  writeln(fout);
  writeln(fout);

  close(fnivel);
  flush(fout);
End;
{ *********************************************************   }



procedure ShowDimenCSV(var camino: TcaminFi; var fout: text;
                       NoNiveleUt, IndNivelMx: byte);

  var IndiNivel: byte;
      gout: Tfichero;

Begin
  for IndiNivel:= IndNivelMx to NoNiveleUt do
    begin
      iniTitleDimen(fout, IndiNivel, 'c');

      ShowNiveleConCSV(fout, IndiNivel, camino);

      NombraFichDim(gout, camino, IndiNivel);
      reset(gout);

      ShowMedidasCSV(fout, gout, (IndiNivel = NoNiveleUt)); {IndiNivel > 1}

      close(gout);
    end;
End;


procedure iniTituRegiCSV(var fout: text; var gout: Tfichero;
                      var vNivAmbSup: TRegNivel;
                      IndiAmbSup, IndiAmbInf: byte);

  var nomb: TnombreFi;
      r: Tnumero;
      
Begin
  writeln(fout);
  ShowSignifica('regiona', 'c', fout);
  writeln(fout);
  writeln(fout, '"ELECTORAL REGIONALISM"');
  writeln(fout);
  write(fout, '"Upper aggregation level : ');
  tomaNombreNivel(nomb, IndiAmbSup);
  writeln(fout, nomb, '"');

  write(fout, '"Upper level item : ');
  writeln(fout, vNivAmbSup.NomNivel, '"');

  writeln(fout);

  write(fout, '"Lower aggregation level : ');
  tomaNombreNivel(nomb, IndiAmbInf);
  writeln(fout, nomb, '"');

  seek(gout, 1);  read(gout, r);

  writeln(fout);
 { Total voto PANE en mbito superior }
  write(fout, '"Total (PANE) regionalist vote at the upper level item="');
  introComaCSV(fout, 3);
  escridatCSV(fout, r, TRUE);
  writeln(fout);

  write(fout, sepacsv);
  write(fout, '"VRta"', sepacsv);
  write(fout, '"VRtaD"', sepacsv);
  write(fout, '"VRDe"', sepacsv);
  writeln(fout, '"VRD"');   
End;


procedure iniTituLinkageCSV(var fout: text; var gout: Tfichero;
                      var vNivAmbSup: TRegNivel;
                      IndiAmbSup, IndiAmbInf: byte);

  var nomb: TnombreFi;
      r, totENP, ENPavg, ENPw: Tnumero;
Begin
  writeln(fout);
  ShowSignifica('linkage', 'c', fout);
  writeln(fout);
  writeln(fout, '"PARTY LINKAGE"');
  writeln(fout);
  write(fout, '"Upper aggregation level : ');
  tomaNombreNivel(nomb, IndiAmbSup);
  writeln(fout, nomb, '"');

  write(fout, '"Upper level item : ');
  writeln(fout, vNivAmbSup.NomNivel, '"');

  writeln(fout);

  write(fout, '"Lower aggregation level : ');
  tomaNombreNivel(nomb, IndiAmbInf);
  writeln(fout, nomb, '"');

  seek(gout, 2);

  read(gout, totENP);  writeln(fout);
  write(fout, '"ENP at the upper level item = "');
  introComaCSV(fout, 2);
  escridatCSV(fout, totENP, TRUE);
  writeln(fout);

  read(gout, ENPavg);  
  writeln(fout);
  write(fout, '"Average ENP in the lower aggregation level = "');
  introComaCSV(fout, 3);
  escridatCSV(fout, ENPavg, TRUE);
 
  write(fout, '"Cox inflation rate (%) ="');
  introComaCSV(fout, 1);
  r:= inflationCox(totENP, ENPavg);
  escridatCSV(fout, r, TRUE);

  write(fout, '"Moenius & Kasuya inflation rate(%) ="');
  introComaCSV(fout, 2);
  r:= inflationMoKa(totENP, ENPavg);
  escridatCSV(fout, r, TRUE);
  writeln(fout);

  read(gout, ENPw);
  writeln(fout);
  write(fout, '"Weighted average ENP in the lower aggregation level="');
  introComaCSV(fout, 3);
  escridatCSV(fout, ENPw, TRUE);

  write(fout, '"Cox weighted inflation rate (%) = "');
  introComaCSV(fout, 2);
  r:= inflationCox(totENP, ENPw);
  escridatCSV(fout, r, TRUE);

  write(fout, '"Moenius & Kasuya weighted inflation rate (%) = "');
  introComaCSV(fout, 3);
  r:= inflationMoKa(totENP, ENPw);
  escridatCSV(fout, r, TRUE);
  writeln(fout);

  write(fout, sepacsv);
  write(fout, '"ENP"', sepacsv);
  write(fout, '"CKr"', sepacsv);
  write(fout, '"Coxr"', sepacsv);
  writeln(fout, '"MKr"');  
End;



procedure ShowRegion(var fout: text; var camino: TcaminFi;
                     IndAmbSup, IndAmbInf: byte;
                     ClaseDistrito: boolean);

  label otro;

  const NoRegIni = EqNo +1+nnRegi0Fi;
        NoDimensD = EqNo+ 1+ NNindxFichReg; { = EqNo + 1 + 4}


  var gout: Tfichero;
      vNivAmbSup: TRegNivel;
      NoItmsAI, iItmAS: TItmsNivel;
      med: PVector;
      Rc: PMatrix;


Begin
  iItmAS:= 0;

  while GetItm(camino, vNivAmbSup, IndAmbSup, iItmAS) do
    begin
       NombraFichReg(gout, camino, IndAmbSup, IndAmbInf, vNivAmbSup, 'reg');
       {$I-}
       reset(gout);
       {$I+}

       if IoResult <> 0 then goto otro;

       iniTituRegiCSV(fout, gout, vNivAmbSup, IndAmbSup, IndAmbInf);
       ShowMedidaxCSV(fout, gout, NoItmsAI, NoRegIni, iiRegi, nnRegi,  NoDimensD);
       if NoItmsAI > 0 then
         begin
           ShowEstimasCSV(fout, gout, NoItmsAI, NoRegIni, iiRegi,nnRegi,
                          NoDimensD, med, Rc, cdistri);
           if ClaseDistrito then
              ShowEstimaClaseCSV(fout, gout, NoItmsAI, NoRegIni, iiRegi,nnRegi,
                              NoDimensD, med, Rc, cdistri);
         end;


       iniTituLinkageCSV(fout, gout, vNivAmbSup, IndAmbSup, IndAmbInf);
       ShowMedidaxCSV(fout, gout, NoItmsAI, NoRegIni, iiENP, nnENP,  NoDimensD);
       if NoItmsAI > 0 then
         begin
           ShowEstimasCSV(fout, gout, NoItmsAI, NoRegIni, iiENP,nnENP,
                          NoDimensD, med, Rc, 1);
           if ClaseDistrito then
              ShowEstimaClaseCSV(fout, gout, NoItmsAI, NoRegIni, iiENP,nnENP,
                              NoDimensD, med, Rc, 1);
         end;


       close(gout);

       otro:
       Inc(iItmAS);
    end;
End;

procedure ShowRegionalCSV(var fout: text; var camino: TcaminFi;
                          NoNiveleUt, IndNivelMx: byte);

  var IndAmbSup, IndAmbInf: byte;

Begin
  for IndAmbSup:= IndNivelMx to NoNiveleUt do
   for IndAmbInf:= Succ(IndAmbSup) to NoNiveleUt do
    ShowRegion(fout, camino, IndAmbSup, IndAmbInf,
             (IndAmbSup=0) and (IndAmbInf= NoNiveleUt));
End;


procedure ShowFiCSV(var camino: TcaminFi;
                    NoNiveleUti, IndNivelAgrMx: byte);
  var fout: text;
Begin
  assign(fout, camino+'result.csv');   rewrite(fout);

  MmbrIndxNiv(fout, 0, 'c');
  showTitulo(camino, fout,'c');
  ShowDimenCSV(camino, fout, NoNiveleUti, IndNivelAgrMx);

  ShowRegionalCSV(fout, camino, NoNiveleUti, IndNivelAgrMx);
  close(fout);
End;


{ fin de dimInOuS }
END.
