{ =====================================================
 Copyright (C) 2007 Francisco A. Ocana & Pablo Onate 

 This file is part of IndElec

 IndElec is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 IndElec is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You have received a copy of the GNU General Public License
 in a file called COPYING which you should have received with
 IndElec. If not, see <http://www.gnu.org/licenses/>.
 ===================================================== 
}
unit MEMBRETE;

{
Routines printing the head of the output files with report style.
}

INTERFACE

procedure MmbrIndxNiv(var fout: text; opcion: byte; tipfich: char);

procedure MmbrIndx(var fout: text; opcion: byte; tipfich: char);



IMPLEMENTATION


procedure creditosTXT(var fout: text);
begin
  write(fout, 'Francisco A. Ocaa Lara, ');
  writeln(fout, 'Dept. Statistics & O.R., ');
  write(fout, 'University of Granada, ');
  writeln(fout, '< focana@ugr.es >.');
  writeln(fout);
end;

procedure creditosCSV(var fout: text);
begin
  write(fout, '"Francisco A. Ocaa Lara, ');
  writeln(fout, 'Dept. Statistics & O.R.," ');
  write(fout, '"University of Granada, ');
  writeln(fout, '< focana@ugr.es >."');
  writeln(fout);
end;

procedure creditosHTML(var fout: text);
begin
  writeln(fout, '<p>');
  write(fout, 'Francisco A. Oca&ntilde;a Lara, ');  
  writeln(fout, 'Dept. Statistics & O.R. <br>');
  write(fout, 'University of Granada, ');
  write(fout, '<tt>focana@ugr.es</tt>');
  writeln(fout, '</p>');
end;

procedure creditosRS(var fout: text);
begin
  write(fout, '# Francisco A. Ocaa Lara, ');
  writeln(fout, 'Dept. Statistics & O.R., ');
  write(fout, '# University of Granada, ');
  writeln(fout, '< focana@ugr.es >.');
  writeln(fout, '#');
end;



{
procedure MmbrIndxNiv(var fout: text; opcion: byte);


  var i: byte;
Begin
  write(fout, 'IndElec by level of data aggregation: ');

  if opcion = 0 then writeln(fout, 'Module Dimensi')
                else writeln(fout, 'Module Volatili');

  creditosTXT(fout);

  write(fout, ' ');
  for i:= 0 to 60 do write(fout, '*');
  writeln(fout);

  flush(fout);
End;
}

procedure MmbrIndxNiv(var fout: text; opcion: byte; tipfich: char);
{
tipfich = 't', a text file
tipfich = 'h', a HTML file
tipfich = 'c', a CSV file
}

  var i: byte;
Begin
  if tipfich='h' 
  then write(fout, '<h2>')
  else if tipfich= 'c' then write(fout, '"');

  write(fout, 'IndElec by level of data aggregation: ');

  if opcion = 0 then write(fout, 'Module Dimensi')
                else write(fout, 'Module Volatili');

  if tipfich='h' 
  then write(fout, '</h2>')
  else if tipfich= 'c' then write(fout, '"');

  writeln(fout);
  
  if tipfich='t' 
  then
    begin
      creditosTXT(fout);
      write(fout, ' ');
      for i:= 0 to 60 do write(fout, '*');
    end
  else if tipfich = 'h' then
      begin
        creditosHTML(fout);
        writeln(fout, '<hr><p> </p>');
      end
  else if tipfich = 'c' then creditosCSV(fout);     

  writeln(fout);

  flush(fout);
End;


{procedure MmbrIndxNivHH(var fout: text; opcion: byte);


Begin
  write(fout, '<h2>IndElec by level of data aggregation: ');

  if opcion = 0 then writeln(fout, 'Module Dimensi</h2>')
                else writeln(fout, 'Module Volatili</h2>');

  creditosHTML(fout);

  writeln(fout, '<hr>');

  writeln(fout, '<p> </p>');

  flush(fout);
End;

procedure MmbrIndx(var fout: text; opcion: byte);


  var i: byte;
Begin
  write(fout, 'IndElec with aggregated data: ');

  if opcion = 0 then writeln(fout, 'Module Dimensi')
                else writeln(fout, 'Module Volatili');

  writeln(fout);

  creditosTXT(fout);

  write(fout, ' ');
  for i:= 0 to 70 do write(fout, '*');
  writeln(fout);
  writeln(fout);

  flush(fout);
End;

procedure MmbrIndxHTML(var fout: text; opcion: byte);

Begin
  write(fout, '<h2>IndElec with aggregated data: ');

  if opcion = 0 then writeln(fout, 'Module Dimensi</h2>')
                else writeln(fout, 'Module Volatili</h2>');

  creditosHTML(fout);

  writeln(fout, '<hr>');
  writeln(fout);

  flush(fout);
End;


procedure MmbrIndxRS(var fout: text; opcion: byte);

  var i: byte;
Begin
  write(fout, '# IndElec with aggregated data: ');

  if opcion = 0 then writeln(fout, 'Module Dimensi')
                else writeln(fout, 'Module Volatili');

  writeln(fout, '#');

  creditosRS(fout);

  writeln(fout, '#');
  for i:= 0 to 70 do write(fout, '#');
  writeln(fout);

  writeln(fout, '#');

  flush(fout);
End;
}

procedure MmbrIndx(var fout: text; opcion: byte; tipfich: char);
{
tipfich = 't', a text file
tipfich = 'h', a HTML file
tipfich = 'c', a CSV file
tipfich = 'r', a R source file
}

  var i: byte;
Begin
  if tipfich ='h'
  then write(fout, '<h2>')
  else if tipfich= 'c' then write(fout, '"')
  else if tipfich= 'r' then write(fout, '# ');

  write(fout, 'IndElec with aggregated data: ');

  if opcion = 0 then write(fout, 'Module Dimensi')
                else write(fout, 'Module Volatili');

  if tipfich='h' 
  then write(fout, '</h2>')
  else if tipfich= 'c' then write(fout, '"');

  writeln(fout);

  if tipfich='t' 
  then
    begin
      creditosTXT(fout);
      write(fout, ' ');
      for i:= 0 to 50 do write(fout, '*');
    end
  else if tipfich = 'h' then
      begin
        creditosHTML(fout);
        writeln(fout, '<hr><p> </p>')
      end
  else if tipfich = 'c' then
      creditosCSV(fout)
  else if tipfich = 'r' then
      begin
        creditosRS(fout);
        for i:= 0 to 50 do write(fout, '#');
      end;

  writeln(fout);
  flush(fout);
End;

END.
