{ =====================================================
 Copyright (C) 2007 Francisco A. Ocana & Pablo Onate 

 This file is part of IndElec

 IndElec is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 IndElec is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You have received a copy of the GNU General Public License
 in a file called COPYING which you should have received with
 IndElec. If not, see <http://www.gnu.org/licenses/>.
 ===================================================== 
}
unit UHTML;

{
Auxiliary routines for creating the ouput HTM files.
}

INTERFACE
uses COMUN, DEFNIVEL, UINPOUT;

procedure writeItmTabla(var f: text; cade: Tcadenhtml; justify: char);

procedure writeHeadTabla(var f: text; cade: Tcadenhtml; justify: char);

procedure IntroMetaHTML(var f: text);

procedure introMarcaHTML(var fout: text; IndiNivel: byte; nom: Tcadanchor);

procedure introMarcaRegiHTML(var camino: TcaminFi; var fout: text;
                 var vNivAmbSup: TRegNivel; IndiAmbSup, IndiAmbInf: byte);

procedure DoFramePrincipal(var camino: TcaminFi);


procedure iniFrameMenuDi(var camino: TcaminFi); 

procedure contiFrameMenuDi(var camino: TcaminFi);

procedure finFrameMenuDi(var camino: TcaminFi);


procedure MarcaFrameMenuI(var camino: TcaminFi; IndiNivel: byte; nom: Tcadanchor);

IMPLEMENTATION


const 
   Npmenu = 'resup.htm';  { HTML document with the menu of rightMenu frames}


procedure writeItmTabla(var f: text; cade: Tcadenhtml; justify: char);

Begin
  case justify of
  'r': write(f, '<td align="right">');
  'l': write(f, '<td align="left">');
  'c': write(f, '<td align="center">');
  else
    write(f, '<td>');
  end;

  write(f, cade);
  writeln(f, '</td>');
End;


procedure writeHeadTabla(var f: text; cade: Tcadenhtml; justify: char);

Begin
  case justify of
  'r': write(f, '<th align="right">');
  'l': write(f, '<th align="left">');
  'c': write(f, '<th align="center">');
  else
    write(f, '<th>');
  end;

  write(f, cade);
  writeln(f, '</th>');
End;

procedure IntroMetaHTML(var f: text);
begin
{ 
 ++ <META http-equiv="Content-Type" content="text/html; charset=ISO-8859-5"> 

write(f, '<meta http-equiv="Content-Type"');
 writeln(f, 'content="text/html; charset=windows-1252>"');}

 writeln(f, '<meta name="generator" content="IndElec">');
 writeln(f, '<meta name="author" content="F.A. Ocana">');
 writeln(f, '<meta name="keywords" content="dimensions of party systems and electoral systems">');
 writeln(f, '<meta name="description" content ="output file by IndElec">');
end;


procedure introMarcaHTML(var fout: text;  IndiNivel: byte;
                         nom: Tcadanchor);
{ 
It writes the name of an HTML anchor. 
}
  var cai: string[2];
begin 
  writeln(fout);
 
  str(IndiNivel, cai);  nom := nom+cai;
  write(fout, '<a name="');
  write(fout, nom);
  writeln(fout,'"></a>');
end;


procedure introMarcaRegiHTML(var camino: TcaminFi; var fout: text;
                 var vNivAmbSup: TRegNivel;
                 IndiAmbSup, IndiAmbInf: byte);

  var nomb: Tcadanchor;
      cai: string[2];
      fmenu: text;
      iItmAS: TItmsNivel;
begin
  writeln(fout);
  iItmAS:= vNivAmbSup.CgClasifica[IndiAmbSup];

  nomb:= 'mR';
  str(IndiAmbSup, cai);   nomb:= nomb+ cai;
  str(IndiAmbInf, cai);   nomb:= nomb+'_'+cai+'_';  
  str(iItmAS, cai);       nomb:= nomb+cai;

  write(fout, '<a name="');
  write(fout, nomb);
  writeln(fout, '"></a>');

{ ++++ introduccin de la marca en el fichero HTML pmenu +++++ }
  assign(fmenu, camino+Npmenu);  append(fmenu);

  writeln(fmenu);
  write(fmenu, '<tr><td><h5><a href="result.htm#');
  write(fmenu, nomb);
  writeln(fmenu, '" target="mainwindow">');

  write(fmenu, 'Item '); write(fmenu, iItmAS);
  write(fmenu, ' of level '); write(fmenu, Succ(IndiAmbSup));
  write(fmenu, ' vs <br> level ');  writeln(fmenu, Succ(IndiAmbInf));

  writeln(fmenu, '</a></h5></td></tr>');

  close(fmenu);
end;


procedure DoFramePrincipal(var camino: TcaminFi);
{ Crea el fichero HTML que gestiona los frames }
 var foutfram: text;
begin
  assign(foutfram, camino+'resultf.htm');   rewrite(foutfram);
  ShowSignifica('cabef', 'h', foutfram);
  close(foutfram);
end;

{**************************************
 Estructura de frames de Dimensi

      resultf.html
  resup.htm   result.htm
******************************************* }


procedure iniFrameMenuDi(var camino: TcaminFi);

{ Inicia la creacin del fichero HTML que contiene el menu para la
estructura de frames para el mdulo Dimensi. }

 var foutm: text;
begin
  assign(foutm, camino+Npmenu);  rewrite(foutm);
  ShowSignifica('pmenu', 'h', foutm);
  close(foutm);
end;

procedure contiFrameMenuDi(var camino: TcaminFi);

{ Inicia la creacin del fichero HTML que contiene el menu para la
estructura de frames para el mdulo Dimensi. }

 var foutm: text;
begin
  assign(foutm, camino+Npmenu);  append(foutm);
  ShowSignifica('pmenuR', 'h', foutm);
  close(foutm);
end;


procedure finFrameMenuDi(var camino: TcaminFi);

{ finaliza la creacin del fichero HTML que contiene el menu para la
estructura de frames para el mdulo Dimensi. }

 var foutm: text;
begin
  assign(foutm, camino+Npmenu);  append(foutm);
  writeln(foutm, '</table></body></html>');
  close(foutm);
end;


procedure MarcaFrameMenuI(var camino: TcaminFi; IndiNivel: byte;
                           nom: Tcadanchor);

 var foutm: text;
     ca2: string[2];

begin
  assign(foutm, camino+Npmenu);  append(foutm);

  writeln(foutm);
  write(foutm, '<tr><td><h5><a href="result.htm#');

  str(IndiNivel, ca2);  nom := nom+ca2;

  write(foutm, nom);
  writeln(foutm, '" target="mainwindow">');
  write(foutm, 'Level ');  writeln(foutm, Succ(IndiNivel));
  writeln(foutm, '</a></h5></td></tr>');

  close(foutm);
end;


End.
