{ =====================================================
 Copyright (C) 2007 Francisco A. Ocana & Pablo Onate 

 This file is part of IndElec

 IndElec is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 IndElec is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You have received a copy of the GNU General Public License
 in a file called COPYING which you should have received with
 IndElec. If not, see <http://www.gnu.org/licenses/>.
 ===================================================== 
}
unit uindelec;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, 
  Utimedid, StdCtrls,
  COMUN,
  UDIMENW, UACERCA,
  XVOLATIL, ADIMENSI, AVOLATI;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Datos1: TMenuItem;
    Opciones1: TMenuItem;
    Tiposdemedidas1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Salir1: TMenuItem;
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label2: TLabel;
    Label4: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Ayuda1: TMenuItem;
    Acercade1: TMenuItem;
    procedure Datos1Click(Sender: TObject);
    procedure Salir1Click(Sender: TObject);
    procedure Tiposdemedidas1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Acercade1Click(Sender: TObject);
    {procedure Button2Click(Sender: TObject);}
  private
    { Private declarations }
  public
    camido: TOInfoFich;
    { Public declarations }
  end;

var
  Form1: TForm1;


implementation

{$R *.DFM}



procedure TForm1.Datos1Click(Sender: TObject);
begin
  if Dimensi
  then
    begin
      if Agregados
      then
        OpenDialog1.FilterIndex:= 3
      else
        OpenDialog1.FilterIndex:= 1;
    end
  else
      OpenDialog1.FilterIndex:= 2;


  if OpenDialog1.Execute
  then
     Edit1.Text:= OpenDialog1.Filename
  else
     ShowMessage('Warning: no data file');
end;

procedure TForm1.Salir1Click(Sender: TObject);
begin
  close;
end;



procedure TForm1.Tiposdemedidas1Click(Sender: TObject);
begin
  BtnRightDlg1.ShowModal;

  if Dimensi
  then
     Edit3.Text:= 'Disproportionality & Dimensions'
  else
     Edit3.Text:= 'Volatility';

  if Agregados
  then
     Edit2.Text:= 'Aggregated Data'
  else
     Edit2.Text:= 'Data with aggregation levels';
end;


procedure TForm1.Button1Click(Sender: TObject);

begin

  if length(Edit1.Text) = 0 then
    begin
      showMessage('Error: select a data file');
      exit;
    end;

  camido.inicializa(Edit1.Text);

  if Dimensi
  then
    begin
      if Agregados
      then
        { Dimensi from aggregated data }
        adimensiw(camido)
      else
        begin
          { Dimensi from data with aggregation levels }
          Form2.pcamido:= @camido;
          Form2.Show;
        end;
    end
  else
    begin
      if Agregados
      then
     { Volati from aggregated data }
          avolatiw(camido)
      else
      { Volati from data with aggregation levels }
          xvolatilw(camido);
    end;
end;

procedure TForm1.Acercade1Click(Sender: TObject);
begin
  AboutBox.Show;
end;

{procedure TForm1.Button2Click(Sender: TObject);
begin
  if Dimensi
  then
     Edit3.Text:= 'Disproportionality & Dimensions'
  else
     Edit3.Text:= 'Volatility';

  if Agregados
  then
     Edit2.Text:= 'Aggregated Data'
  else
     Edit2.Text:= 'Data with aggregation levels';

end;}

end.
