{ =====================================================
 Copyright (C) 2007 Francisco A. Ocana & Pablo Onate 

 This file is part of IndElec

 IndElec is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 IndElec is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You have received a copy of the GNU General Public License
 in a file called COPYING which you should have received with
 IndElec. If not, see <http://www.gnu.org/licenses/>.
 ===================================================== 
}
unit UINPOUT;

{
Auxiliary routines for generating the ouput files of IndElec 
with report style. They arrage the computed indexes and the
statistics in output files, for several formats.
}

INTERFACE

uses COMUN, DEFNIVEL, DIMVECTO;


procedure iniTitleDimen(var fout: text; IndiNivel: byte; tipfich: char);


procedure ShowSignifica(nom: TnombreFi; termi: char; var fout: text);



procedure ShowMedidax(var fout: text; var gout: Tfichero;
            var NoItms: TItmsNivel; NoRegIniFich: word;
            iniciMedidas, noMedidas, tabu, preci: byte;
            NoDimenss: word);

procedure ShowMedidaxH(var fout: text; var gout: Tfichero;
            var NoItms: TItmsNivel;  NoRegIniFich: word;
            iniciMedidas, noMedidas, preci: byte;
            NoDimenss: word);

procedure ShowMedidaxCSV(var fout: text; var gout: Tfichero;
            var NoItms: TItmsNivel;  NoRegIniFich: word;
            iniciMedidas, noMedidas: byte;  NoDimenss: word);


procedure ShowEstimas(var fout: text; var gout: Tfichero;
            NoItms: TItmsNivel; NoRegIniFich: word;
            iniciMedidas, noMedidas, tabu, preci: byte;
            NoDimenss: word; var med: PVector; var Rc: PMatrix;
            distrb: byte);

procedure ShowEstimasH(var fout: text; var gout: Tfichero;
            NoItms: TItmsNivel;  NoRegIniFich: word;
            iniciMedidas, noMedidas, preci: byte; NoDimenss: word;
            var med: PVector; var Rc: PMatrix; distrb: byte);

procedure ShowEstimasCSV(var fout: text; var gout: Tfichero;
            NoItms: TItmsNivel;  NoRegIniFich: word;
            iniciMedidas, noMedidas: byte; 
            NoDimenss: word;
            var med: PVector; var Rc: PMatrix; distrb: byte);



procedure ShowEstimaClase(var fout: text; var gout: Tfichero;
            NoItms: TItmsNivel; NoRegIniFich: word;
            iniciMedidas, noMedidas, tabu, preci: byte;
            NoDimenss: word;
            var med: PVector; var Rc: PMatrix; distrb: byte);

procedure ShowEstimaClaseCSV(var fout: text; var gout: Tfichero;
            NoItms: TItmsNivel;  NoRegIniFich: word;
            iniciMedidas, noMedidas: byte; 
            NoDimenss: word;
            var med: PVector; var Rc: PMatrix; distrb: byte);

procedure ShowEstimClaseH(var fout: text; var gout: Tfichero;
            NoItms: TItmsNivel;  NoRegIniFich: word;
            iniciMedidas, noMedidas, preci: byte;
            NoDimenss: word;
            var med: PVector; var Rc: PMatrix;
            distrb: byte);


IMPLEMENTATION

uses UHTML, COMUTIL, DIMSIGLA, DIMAUXN, DIMESTIM;


procedure iniTitleDimen(var fout: text; IndiNivel: byte; tipfich: char);
{
tipfich = 't', a text file
tipfich = 'h', a HTML file
tipfich = 'c', a CSV file
}
  var nombNiv: TnombreFi;
Begin
  tomaNombreNivel(nombNiv, IndiNivel);

  writeln(fout);

  if tipfich = 'c'  then
    write(fout, '"')
  else if tipfich = 'h' then
    write(fout, '<h2>');

  write(fout, 'INDICES OF DISPROPORTIONALITY & DIMENSIONS IN');

  if tipfich = 'c'  then
   begin
    writeln(fout, '"');
    write(fout, '"');
   end
  else {h, t}
    writeln(fout);

  write(fout, 'THE AGGREGATION LEVEL ');
  write(fout, nombNiv);

  if tipfich = 'c'  then
    writeln(fout, '"')
  else if tipfich = 'h' then
    writeln(fout, '</h2>')
  else 
    writeln(fout);
  
  writeln(fout);
End;


procedure ShowSignifica(nom: TnombreFi; termi: char; var fout: text);
{
  exten = '.cab' (termi='b'),  if tipfich = 't'
}

 var ftt: file of char;
     cx: char;
     

Begin    
  assign(ftt, camIndElec+nom+'.ca'+termi);  reset(ftt);
  repeat
    read(ftt, cx);
    write(fout, cx);
  until Eof(ftt);

  writeln(fout);
  close(ftt);

  flush(fout);
End;
{ ******************************************************** }

{
procedure ShowNiveles(var fout: text; IndiNive: byte;
                      var camino: TcaminFi);

  const tabVot = 13;
        tabEsc = 9;

  var nomNive: TnombreFi;
      fnivel: TfichNivel;
      i, noNiv: TItmsNivel;
      acEsca, acVoto: Tnumero;
      rniv: TRegNivel;

Begin
  tomaNombreNivel(nomNive, IndiNive);
  assign(fnivel, camino+nomNive+'.cg');
  reset(fnivel);

  read(fnivel, rniv);
  noNiv:= rniv.tamano;

  acEsca:= 0;   acVoto:= 0;

  writeln(fout);
  write(fout, 'List of items of ');
  write(fout, nomNive);
  writeln(fout, ' :');

  writeln(fout);
  write(fout, nomNive: lenCadItmNiv);    write(fout, charTabu);
  write(fout, 'Votes': tabVot);          write(fout, charTabu);
  write(fout, 'Seats': tabEsc);        writeln(fout, charTabu);

  write(fout, '************':lenCadItmNiv);  write(fout, charTabu);
  write(fout, '*******':tabVot);             write(fout, charTabu);
  write(fout, '******':tabEsc);              writeln(fout, charTabu);

  for i:= 0 to noNiv do
    begin
      read(fnivel, rniv);

      write(fout, rniv.NomNivel:lenCadItmNiv);
      write(fout, charTabu);
      escridat(fout, rniv.votos, tabVot, 0, TRUE, FALSE);
      escridat(fout, rniv.tamano, tabEsc, 0, TRUE, TRUE);

      acVoto:= acVoto + rniv.votos;
      acEsca:= acEsca + rniv.tamano;
    end;

  writeln(fout);
  write(fout, 'SUM':lenCadItmNiv);        write(fout, charTabu);
  escridat(fout, acVoto, tabVot, 0, TRUE, FALSE);
  escridat(fout, acEsca, tabEsc, 0, TRUE, TRUE);
  writeln(fout);
  writeln(fout);

  close(fnivel);
  flush(fout);
End;
 *********************************************************   }



procedure ShowMedidax(var fout: text; var gout: Tfichero;
            var NoItms: TItmsNivel;  NoRegIniFich: word;
            iniciMedidas, noMedidas, tabu, preci: byte;
            NoDimenss: word);

{
   NoRegIniFich = Nmero de registros iniciales del fichero (hasta llegar a vNive) ,
   iniciMedidas = ndice inicial de las medidas,
      noMedidas = Nmero de medidas,
           tabu = amplitud tabulador,
          preci = precisin,
      NoDimenss = nmero total de registros por items (incluyendo los de vNive) ,
}

  var r: Tnumero;
      j: TItmsNivel;
      rniv: TRegNivel;
      i: byte;
      posIni: word;

Begin
  reset(gout);

  read(gout, r);    NoItms:= Trunc(r);

  Dec(noMedidas);
  posIni:= NoRegIniFich + EqNo + IniciMedidas;

  for j:= 0 to NoItms do
    begin
      seek(gout, NoRegIniFich);
      ReadNivel(gout, rniv);

      write(fout, rniv.NomNivel: lenCadItmNiv);   write(fout, charTabu);

      seek(gout, posIni);

      for i:= 0 to noMedidas do
        begin
          read(gout, r);
          escridat(fout, r, tabu, preci, TRUE, FALSE);
        end;

      writeln(fout);

      Inc(posIni, NoDimenss);
      Inc(NoRegIniFich, NoDimenss);
    end;

  flush(fout);
End;
{ *************************************************************}



procedure ShowMedidaxH(var fout: text; var gout: Tfichero;
            var NoItms: TItmsNivel;  NoRegIniFich: word;
            iniciMedidas, noMedidas, preci: byte;
            NoDimenss: word);

{
   NoRegIniFich = Nmero de registros iniciales del fichero (hasta llegar a vNive) ,
   iniciMedidas = ndice inicial de las medidas,
      noMedidas = Nmero de medidas,
           tabu = amplitud tabulador,
          preci = precisin,
      NoDimenss = nmero total de registros por items (incluyendo los de vNive) ,
}

  var r: Tnumero;
      j: TItmsNivel;
      rniv: TRegNivel;
      i: byte;
      posIni: word;

Begin
  reset(gout);

  read(gout, r);    NoItms:= Trunc(r);

  Dec(noMedidas);
  posIni:= NoRegIniFich + EqNo + IniciMedidas;

  for j:= 0 to NoItms do
    begin
      seek(gout, NoRegIniFich);
      ReadNivel(gout, rniv);

      writeln(fout, '<tr>');
      writeItmTabla(fout, rniv.NomNivel, 'l');

      seek(gout, posIni);

      for i:= 0 to noMedidas do
        begin
          read(gout, r);
          escridaHT(fout, r, preci);
        end;

      writeln(fout, '</tr>');

      Inc(posIni, NoDimenss);
      Inc(NoRegIniFich, NoDimenss);
    end;

  flush(fout);
End;
{ *************************************************************}

procedure ShowMedidaxCSV(var fout: text; var gout: Tfichero;
            var NoItms: TItmsNivel;  NoRegIniFich: word;
            iniciMedidas, noMedidas: byte;
            NoDimenss: word);

{
   NoRegIniFich = nmero de registros iniciales del fichero (hasta llegar a vNive) ,
   iniciMedidas = ndice inicial de las medidas,
      noMedidas = nmero de medidas,
      NoDimenss = nmero total de registros por items (incluyendo los de vNive) ,
}

  var r: Tnumero;
      j: TItmsNivel;
      rniv: TRegNivel;
      i: byte;
      posIni: word;

Begin
  reset(gout);

  read(gout, r);    NoItms:= Trunc(r);

  Dec(noMedidas);
  posIni:= NoRegIniFich + EqNo + IniciMedidas;

  for j:= 0 to NoItms do
    begin
      seek(gout, NoRegIniFich);
      ReadNivel(gout, rniv);

      write(fout,'"');
      write(fout, rniv.NomNivel);   
      write(fout, '"');

      seek(gout, posIni);

      for i:= 0 to noMedidas do
        begin
          read(gout, r);
          escridatCSV(fout, r, FALSE);
        end;

      writeln(fout);

      Inc(posIni, NoDimenss);
      Inc(NoRegIniFich, NoDimenss);
    end;

  flush(fout);
End;
{ *************************************************************}



procedure escritura(var fout: text;  var gy: Tfichero;
                    posi: word;  noMedidax: byte;
                    tabu, preci: byte);

  var j: byte;
      rx: Tnumero;
      crx: Tcadreal absolute rx;

Begin
  for j:= 0 to noMedidax do
    begin
      seek(gy, posi);
      read(gy, rx);

      if crx = '*'
      then
        begin
          write(fout, crx: tabu);
          write(fout, charTabu);
        end
      else
          escridat(fout, rx, tabu, preci, TRUE, FALSE);

      Inc(posi, 5);
    end;

  writeln(fout);
End;
{ **************************************************************+ }


procedure escrituraCSV(var fout: text; var gy: Tfichero;
                       posi: word;  noMedidax: byte);

  var j: byte;
      rx: Tnumero;
      crx: Tcadreal absolute rx;

Begin
  for j:= 0 to noMedidax do
    begin
      seek(gy, posi);
      read(gy, rx);

      if crx = '*'
      then
        begin
          write(fout, sepacsv, crx);
        end
      else
          escridatCSV(fout, rx, FALSE);

      Inc(posi, 5);
    end;

  writeln(fout);
End;
{ **************************************************************+ }


procedure escrituraH(var fout: text; var gy: Tfichero;
                    posi: word;  noMedidax: byte;
                    preci: byte);

{ versin HTML de escritura }

  var j: byte;
      rx: Tnumero;
      crx: Tcadreal absolute rx;

Begin
  for j:= 0 to noMedidax do
    begin
      seek(gy, posi);
      read(gy, rx);

      if crx = '*'
      then
          writeItmTabla(fout, crx, 'r')
      else
          escridaHT(fout, rx, preci);

      Inc(posi, 5);
    end;

  writeln(fout, '</tr>');
End;
{ **************************************************************+ }


procedure ShowEstima1(var fout: text; noMedidas, tabu, preci: byte);
  var gy: Tfichero;

Begin
  Dec(noMedidas);

  assign(gy, camIndElec+'datum.aux');  reset(gy);

  writeln(fout);

  write(fout, ' Min':lenCadItmNiv);  write(fout, charTabu);
  escritura(fout, gy, 0, noMedidas, tabu, preci);

  write(fout, 'Q1': lenCadItmNiv);  write(fout, charTabu);
  escritura(fout, gy, 1, noMedidas, tabu, preci);

  write(fout, 'Me': lenCadItmNiv);   write(fout, charTabu);
  escritura(fout, gy, 2, noMedidas, tabu, preci);

  write(fout, 'Q3': lenCadItmNiv);    write(fout, charTabu);
  escritura(fout, gy, 3, noMedidas, tabu, preci);

  write(fout, 'Max': lenCadItmNiv);  write(fout, charTabu);
  escritura(fout, gy, 4, noMedidas, tabu, preci);

  close(gy);
  flush(fout);
End;
{ **************************************************************** }

procedure ShowEstima1CSV(var fout: text; noMedidas: byte);
  var gy: Tfichero;

Begin
  Dec(noMedidas);

  assign(gy, camIndElec+'datum.aux');  reset(gy);

  writeln(fout);

  write(fout, '"Min"');
  escrituraCSV(fout, gy, 0, noMedidas);

  write(fout, '"Q1"');
  escrituraCSV(fout, gy, 1, noMedidas);

  write(fout, '"Me"');
  escrituraCSV(fout, gy, 2, noMedidas);

  write(fout, '"Q3"');
  escrituraCSV(fout, gy, 3, noMedidas);

  write(fout, '"Max"');
  escrituraCSV(fout, gy, 4, noMedidas);

  close(gy);
  flush(fout);
End;
{ **************************************************************** }


procedure ShowEstima1H(var fout: text; noMedidas, preci: byte);
  var gy: Tfichero;

Begin
  Dec(noMedidas);

  assign(gy, camIndElec+'datum.aux');  reset(gy);

  writeln(fout);

  writeln(fout, '<tr>');
  writeHeadTabla(fout, ' Min', 'c');
  escrituraH(fout, gy, 0, noMedidas, preci);

  writeln(fout, '<tr>');
  writeHeadTabla(fout, 'Q1', 'c');
  escrituraH(fout, gy, 1, noMedidas, preci);

  writeln(fout, '<tr>');
  writeHeadTabla(fout, 'Me', 'c');
  escrituraH(fout, gy, 2, noMedidas, preci);

  writeln(fout, '<tr>');
  writeHeadTabla(fout, 'Q3', 'c');
  escrituraH(fout, gy, 3, noMedidas, preci);

  writeln(fout, '<tr>');
  writeHeadTabla(fout, 'Max', 'c');
  escrituraH(fout, gy, 4, noMedidas, preci);

  close(gy);
  flush(fout);
End;
{ **************************************************************** }


procedure ShowEstimax(var med: PVector; var Rc: Pmatrix;
                     var fout: text;
                     noMedidas, tabu, preci: byte);

{
Given a mean vector and a covarince matrix, it shows such statistics and also
computes and shows the sd's and the Pearson's coefficient of variations 
}

  var i, j: byte;

Begin
  writeln(fout);
  Dec(noMedidas);

  write(fout, 'Mean':lenCadItmNiv);   write(fout, charTabu);
  for i:= 0 to noMedidas do
      escridat(fout, med^[i], tabu, preci, TRUE, FALSE);

  writeln(fout);

  write(fout, 'Sd. ': lenCadItmNiv);   write(fout, charTabu);
  for i:= 0 to noMedidas do
     escridat(fout, SQRT(Rc^[i]^[i]), tabu, preci, TRUE, FALSE);

  writeln(fout);


  write(fout, '% CV': lenCadItmNiv);   write(fout, charTabu);
  for i:= 0 to noMedidas do
    begin
      if ABS( med^[i] ) < 1E-10
      then
        begin
          write(fout, ' ':tabu);
          write(fout, charTabu);
        end
      else
   escridat(fout, 100*SQRT(Rc^[i]^[i])/ABS(med^[i]), tabu, preci, TRUE, FALSE);
    end;

  writeln(fout);

  delVectoR(med, noMedidas);

  for i:= 1 to noMedidas do
      for j:= 0 to Pred(i) do
        begin
          if ABS( Rc^[i]^[i] * Rc^[j]^[j] ) < 1E-10
          then
             Rc^[i]^[j]:= 3 { a NA label }
          else
             Rc^[i]^[j] := SQR(Rc^[i]^[j])/( Rc^[i]^[i]*Rc^[j]^[j] );
        end;


  writeln(fout);
  writeln(fout, 'Matrix of squared correlations:');
  writeln(fout);

  write(fout, ' ': lenCadItmNiv);    write(fout, charTabu);
  for i:= 1 to Succ(noMedidas) do
    begin
      write(fout, i: tabu);
      write(fout, charTabu);
    end;
  writeln(fout);

  for i:= 0 to noMedidas do
    begin
      write(fout, Succ(i): lenCadItmNiv);  write(fout, charTabu);

      for j:= 0 to i do
        begin
          if j = i
          then
            begin
              write(fout, '1': tabu);
              write(fout, charTabu);
            end
          else
            begin
             if Rc^[i]^[j] > 2
             then
               begin
                 write(fout, ' ':tabu);
                 write(fout, charTabu);
               end
             else
               escridat(fout, Rc^[i]^[j], tabu, preci, TRUE, FALSE);
            end;
        end;

      writeln(fout);
    end;


  writeln(fout);
  writeln(fout);
  delSimetri(Rc, noMedidas);
  flush(fout);
End;
{ **************************************************************** }

procedure ShowEstimas(var fout: text; var gout: Tfichero;
               NoItms: TItmsNivel; NoRegIniFich: word;
               iniciMedidas, noMedidas, tabu, preci: byte;
               NoDimenss: word; var med: PVector; var Rc: PMatrix;
               distrb: byte);

Begin
  IniEstimax(gout,NoItms, NoRegIniFich, iniciMedidas, noMedidas, NoDimenss);
  Estimar1(noMedidas);
  ShowEstima1(fout,noMedidas, tabu, preci);

  if distrb=0
  then
  Estimax(med,Rc,NoItms,gout,NoRegIniFich,iniciMedidas, noMedidas,NoDimenss)
  else
  EstimaxPROB(med,Rc,NoItms,gout,NoRegIniFich,iniciMedidas,noMedidas,
              NoDimenss, distrb = 1);

  ShowEstimax(med,Rc,fout,noMedidas,tabu, preci);
End;



procedure ShowEstimaxCSV(var med: PVector; var Rc: Pmatrix;
                     var fout: text; noMedidas: byte);

  var i, j: byte;

Begin
  writeln(fout);
  Dec(noMedidas);

  write(fout, '"Mean"');
  for i:= 0 to noMedidas do
      escridatCSV(fout, med^[i], FALSE);

  writeln(fout);

  write(fout, '"Sd. "');
  for i:= 0 to noMedidas do
     escridatCSV(fout, SQRT(Rc^[i]^[i]), FALSE);

  writeln(fout);


  write(fout, '"% CV"');
  for i:= 0 to noMedidas do
    begin
      if ABS( med^[i] ) < 1E-10
      then
         write(fout, sepacsv)
      else
       escridatCSV(fout, 100*SQRT(Rc^[i]^[i])/ABS(med^[i]), FALSE);
    end;

  writeln(fout);

  delVectoR(med, noMedidas);

  for i:= 1 to noMedidas do
    begin
      for j:= 0 to Pred(i) do
        begin
          if ABS( Rc^[i]^[i] * Rc^[j]^[j] ) < 1E-10
          then
             Rc^[i]^[j]:= 3
          else
             Rc^[i]^[j] := SQR(Rc^[i]^[j])/( Rc^[i]^[i]*Rc^[j]^[j] );
        end;
    end;

  writeln(fout);
  writeln(fout, '"Matrix of squared correlations:"');
  writeln(fout);

  for i:= 1 to Succ(noMedidas) do
    begin
      write(fout, sepacsv);
      write(fout, i);
    end;
  writeln(fout);

  for i:= 0 to noMedidas do
    begin
      write(fout, Succ(i));

      for j:= 0 to i do
        begin
          if j = i
          then
            write(fout, sepacsv, 1)            
          else
            begin
             if Rc^[i]^[j] > 2
             then
                write(fout, sepacsv)
             else
               escridatCSV(fout, Rc^[i]^[j], FALSE);
            end;
        end;

      writeln(fout);
    end;


  writeln(fout);
  writeln(fout);
  delSimetri(Rc, noMedidas);
  flush(fout);
End;
{*******************************}


procedure ShowEstimasCSV(var fout: text; var gout: Tfichero;
                      NoItms: TItmsNivel;  NoRegIniFich: word;
                      iniciMedidas, noMedidas: byte;
                      NoDimenss: word; var med: PVector; var Rc: PMatrix;
                      distrb: byte);
Begin
  IniEstimax(gout,NoItms, NoRegIniFich, iniciMedidas, noMedidas, NoDimenss);
  Estimar1(noMedidas);
  ShowEstima1CSV(fout,noMedidas);

  if distrb=0
  then
  Estimax(med,Rc,NoItms,gout,NoRegIniFich,iniciMedidas, noMedidas,NoDimenss)
  else
  EstimaxPROB(med,Rc,NoItms,gout,NoRegIniFich,iniciMedidas, noMedidas,
              NoDimenss, distrb=1);

  ShowEstimaxCSV(med,Rc,fout,noMedidas);
End;


procedure tipoDistribu(var fout: text;  distrb: byte);
Begin
  if distrb = 0
  then
     write(fout, ' uniform distribution ')
  else
   begin
     if distrb = 1
     then
        write(fout, ' distribution of votes ')
     else
        write(fout, ' distribution of seats ');
   end;

End;

procedure iniShowStimClase(var fout: text; distrb, clase: byte);
Begin
  writeln(fout);
  write(fout, ' * Summary statistics at districts of TYPE ');
  writeln(fout, clase);
  
  write(fout, ' (');
  tipoDistribu(fout, distrb);
  writeln(fout, ')');
End;

procedure ShowEstimaClase(var fout: text; var gout: Tfichero;
               NoItms: TItmsNivel;  NoRegIniFich: word;
               iniciMedidas, noMedidas, tabu, preci: byte;
               NoDimenss: word;  var med: PVector; var Rc: PMatrix;
               distrb: byte);

  var clase: byte;
      noItmsClase: TItmsNivel;

Begin
  for clase:= 1 to cNoDistritClases do
    begin 
      iniShowStimClase(fout, distrb, clase);

      if IniEstiSel(gout, NoItms, NoItmsClase, NoRegIniFich, iniciMedidas,
                   noMedidas, NoDimenss, clase) then
        begin
          writeln(fout);  writeln(fout);
          continue;
        end;

      Estimar1(noMedidas);
      ShowEstima1(fout, noMedidas, tabu, preci);

      if distrb=0
      then
      EstimaxSel(med, Rc, NoItms, NoItmsClase, gout, NoRegIniFich, iniciMedidas,
                 noMedidas, NoDimenss, clase)
      else
      EstimaxSelPROB(med,Rc,NoItms,NoItmsClase,gout, NoRegIniFich, iniciMedidas,
                     noMedidas, NoDimenss,clase, distrb=1);


      ShowEstimax(med, Rc, fout, noMedidas, tabu, preci);
    end;
End;


procedure iniShowStimClaseCSV(var fout: text; distrb, clase: byte);
Begin
  writeln(fout);
  write(fout, '"Summary statistics at districts of TYPE ');
  writeln(fout, clase, '"');
  write(fout, '" (');
  tipoDistribu(fout, distrb);
  writeln(fout, ')"');
End;

procedure ShowEstimaClaseCSV(var fout: text; var gout: Tfichero;
                      NoItms: TItmsNivel;  NoRegIniFich: word;
                      iniciMedidas, noMedidas: byte;
                      NoDimenss: word;
                      var med: PVector; var Rc: PMatrix; distrb: byte);

  var clase: byte;
      noItmsClase: TItmsNivel;


Begin
  for clase:= 1 to cNoDistritClases do
    begin
      iniShowStimClaseCSV(fout, distrb, clase); 

      if IniEstiSel(gout, NoItms, NoItmsClase, NoRegIniFich, iniciMedidas,
                   noMedidas, NoDimenss, clase) then
        begin
          writeln(fout);  writeln(fout);
          continue;
        end;

      Estimar1(noMedidas);
      ShowEstima1CSV(fout, noMedidas);

      if distrb=0
      then
      EstimaxSel(med, Rc, NoItms, NoItmsClase, gout, NoRegIniFich, iniciMedidas,
                 noMedidas, NoDimenss, clase)
      else
      EstimaxSelPROB(med,Rc,NoItms,NoItmsClase,gout, NoRegIniFich, iniciMedidas,
                     noMedidas, NoDimenss,clase, distrb=1);


      ShowEstimaxCSV(med, Rc, fout, noMedidas);

    end;
End;


procedure ShowEstimaxH(var med: PVector; var Rc: Pmatrix;
                     var fout: text;
                     noMedidas, preci: byte);

  var i, j: byte;

Begin
  writeln(fout);
  Dec(noMedidas);

  writeln(fout, '<tr>');
  writeHeadTabla(fout, 'Mean', 'c');
  for i:= 0 to noMedidas do
      escridaHt(fout, med^[i], preci);

  writeln(fout, '</tr> <tr>');

  writeHeadTabla(fout, 'Sd. ', 'c');
  for i:= 0 to noMedidas do
     escridaHt(fout, SQRT(Rc^[i]^[i]), preci);

  writeln(fout, '</tr> <tr>');

  writeHeadTabla(fout, '% CV', 'c');
  for i:= 0 to noMedidas do
    begin
      if ABS( med^[i] ) < 1E-10
      then        
        writeItmTabla(fout, ' ', 'r')        
      else
       escridaHT(fout, 100*SQRT( Rc^[i]^[i] ) / ABS(med^[i]), preci);
    end;

  writeln(fout, '</tr> </table> </p>');


  delVectoR(med, noMedidas);

  for i:= 1 to noMedidas do
    begin
      for j:= 0 to Pred(i) do
        begin
          if ABS( Rc^[i]^[i] * Rc^[j]^[j] ) < 1E-10
          then
             Rc^[i]^[j]:= 3
          else
             Rc^[i]^[j] := SQR(Rc^[i]^[j])/( Rc^[i]^[i]*Rc^[j]^[j] );
        end;
    end;

 
  writeln(fout, '<h4>Matrix of squared correlations:</h4>');

  writeln(fout, '<p> <table cellspacing="10">  <tr>');

  writeln(fout, '<td> </td>');
  for i:= 1 to Succ(noMedidas) do
    begin
      write(fout, '<th align="right">');
      write(fout, i);
      writeln(fout, '</th>');
    end;
  writeln(fout, '</tr>');

  for i:= 0 to noMedidas do
    begin
      writeln(fout, '<tr> <th align="right">');
      write(fout, Succ(i));
      writeln(fout, '</th>');

      for j:= 0 to i do
        begin
          if j = i
          then            
            writeItmTabla(fout, '1', 'r')            
          else
            begin
             if Rc^[i]^[j] > 2
             then
                writeln(fout, '<td> </td>')
             else
               escridaHT(fout, Rc^[i]^[j], preci);
            end;
        end;

      writeln(fout, '</tr>');
    end;


  writeln(fout, '</table> </p>');
  writeln(fout);
  delSimetri(Rc, noMedidas);
  flush(fout);
End;
{ ******************************************************* }

procedure ShowEstimasH(var fout: text; var gout: Tfichero;
                      NoItms: TItmsNivel;  NoRegIniFich: word;
                      iniciMedidas, noMedidas, preci: byte;
                      NoDimenss: word; var med: PVector; var Rc: PMatrix;
                      distrb: byte);

Begin
  IniEstimax(gout,NoItms, NoRegIniFich, iniciMedidas, noMedidas, NoDimenss);
  Estimar1(noMedidas);
  ShowEstima1H(fout,noMedidas, preci);

  if distrb=0
  then
  Estimax(med,Rc,NoItms,gout,NoRegIniFich,iniciMedidas, noMedidas,NoDimenss)
  else
  EstimaxPROB(med,Rc,NoItms,gout,NoRegIniFich,iniciMedidas, noMedidas,
              NoDimenss, distrb=1);

  ShowEstimaxH(med,Rc,fout,noMedidas,preci);
End;


procedure iniShowStimClaseH(var fout: text; distrb, clase: byte);
Begin
   writeln(fout, '<h4>');
   write(fout, 'Summary statistics at districts of TYPE ');
   write(fout, clase);
   writeln(fout, '</h4>');
   write(fout, '(');
   tipoDistribu(fout,distrb);
   writeln(fout, ')<br />');
End;

procedure ShowEstimClaseH(var fout: text; var gout: Tfichero;
                      NoItms: TItmsNivel;  NoRegIniFich: word;
                      iniciMedidas, noMedidas, preci: byte;
                      NoDimenss: word;
                      var med: PVector; var Rc: PMatrix; distrb: byte);

  var clase: byte;
      noItmsClase: TItmsNivel;


Begin
  for clase:= 1 to cNoDistritClases do
    begin
      iniShowStimClaseH(fout, distrb, clase);

      if IniEstiSel(gout, NoItms, NoItmsClase, NoRegIniFich, iniciMedidas,
                   noMedidas, NoDimenss, clase) then
        begin
          writeln(fout, '<p> </p>');
          continue;
        end;

      Estimar1(noMedidas);

      writeln(fout, '<p><table cellspacing="10">');
      ShowEstima1H(fout, noMedidas, preci);

      if distrb=0
      then
      EstimaxSel(med, Rc, NoItms, NoItmsClase, gout, NoRegIniFich, iniciMedidas,
                 noMedidas, NoDimenss, clase)
      else
      EstimaxSelPROB(med,Rc,NoItms,NoItmsClase,gout, NoRegIniFich, iniciMedidas,
                     noMedidas, NoDimenss,clase, distrb=1);
      

      ShowEstimaxH(med, Rc, fout, noMedidas, preci);
    end;
End;


END.
