{ =====================================================
 Copyright (C) 2007 Francisco A. Ocana & Pablo Onate 

 This file is part of IndElec

 IndElec is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 IndElec is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You have received a copy of the GNU General Public License
 in a file called COPYING which you should have received with
 IndElec. If not, see <http://www.gnu.org/licenses/>.
 ===================================================== 
}
unit UMACSV;

{
Create the CSV files with matrix data style from the ouput
of IndElec 
}

interface

uses COMUN;

procedure MatrDDCSV(var camino: TcaminFi;
                    NoNiveleUt, IndNivelAgrMx: byte);

procedure MtCSVRegional(var camino: TcaminFi;
                        NoNiveleUt, IndNivelAgrMx: byte);


procedure MCSVVolatilidad(var cami2: TcaminFi;
                          var infoFixx: TOInfoFich;
                          NoNiveleUt, IndNivelAgrMx: byte);



implementation

uses DEFNIVEL, DIMDEFN, 
     DIMAUXN, COMUTIL, DIMSIGLA, 
     DIMENSIU, DIMREG, VOLADIM;


     

procedure MatNivelCSV(var f: text; var vNivec: TRegNivel);
  var i: byte;
Begin
  for i:= vNivec.IndNiveAgrMax to vNivec.NoNiveleUti do
    begin
      write(f, sepacsv);
      write(f, vNivec.CgClasifica[i]);      
    end;

  write(f, sepacsv);  write(f, vNivec.tamano);
  escridatEEcsv(f, vNivec.votos, FALSE);
End;


procedure MtCSV1Itm(var f: text;
                    var gout: Tfichero; NoMedidas: word);

  var vNivec: TRegNivel;
      i: word;
      r: Tnumero;

Begin
  ReadNivel(gout, vNivec);

  MatNivelCSV(f, vNivec);

  for i:= 1 to NoMedidas do
    begin
      read(gout, r);
      escridatCSV(f, r, FALSE);
    end;
  
End;


{ *********************************************************}

procedure MtCSVPartiesItm(var f: text; var gPou: TfichParty);
 var PaO: TParty;
     noParti: TRgPartido;
     i: integer;

Begin
  read(gPou, PaO);
  noParti:= trunc(PaO.Ep);

  for i:= 0 to noParti do
    begin
      read(gPou, PaO);
      
      if i < MaxPartiPrint then
        begin
          write(f, sepacsv, '"');
          write(f, PaO.SiglasCandi);
          write(f, '"');

          escridatEEcsv(f, PaO.Vp, FALSE);
          escridatEEcsv(f, PaO.Ep, FALSE);
        end;
    end;

  { Case: 1+noParti < maxPartyPrint }
  if Succ(noParti) < MaxPartiPrint then
    begin
      for i:=1 to MaxPartiPrint-Succ(noParti) do
        write(f, sepacsv, sepacsv, sepacsv);
    end;
End;

procedure MtCSVDDxNivel(var f: text; var camino: TcaminFi;
                        IndiNivel: byte);

 var gout: Tfichero;
     r: Tnumero;
     it, NoItms: TItmsNivel;
     gPou: TfichParty;


Begin
  NombraFichDim(gout, camino, IndiNivel);
  reset(gout);

  if IoResult <> 0 then exit;

  NombraFichPartyD(gPou, camino, IndiNivel);
  reset(gPou);

  if IoResult <> 0 then  
    begin
      close(gout);
      exit;
    end;

  read(gout, r);   NoItms:= trunc(r);
  read(gout, r);

  for it:= 0 to NoItms do
    begin
      write(f, Succ(IndiNivel));   

      MtCSV1Itm(f, gout, NNIndexs);
      MtCSVPartiesItm(f, gPou);

      writeln(f);
    end;

  close(gout);
  close(gPou);
  flush(f)
End;


procedure CabeceIndics(var f: text; nom: TnombreFi; iini, ifin: byte);

  var fhead: text;
      i: byte;
      nomx: string[20];

Begin
  nomx:= nom+'.txt';
  assign(fhead, camIndElec+nomx); reset(fhead);
  readln(fhead);  readln(fhead);

  for i:= 1 to ifin do
    begin  
      leeCadenBlank(fhead,@nomx,14);
      if i < iini then continue;               
      nomx:= '"'+nomx+'"';     
      write(f,sepacsv); write(f, nomx);    
    end;

  close(fhead);
End;

procedure CabeItemLevels(var f: text; NoNiveleUt, IndNivelAgrMx: byte);
 var cad: string[12];
     i: byte;
Begin
  write(f, '"Level"');
  for i:= IndNivelAgrMx to NoNiveleUt do
    begin
      str(Succ(i), cad);
      cad:= '"Lev'+cad+'.Code"';
      write(f, sepacsv); write(f, cad);
    end;

  write(f, sepacsv); write(f, '"Seats"');
  write(f, sepacsv); write(f, '"Votes"');
End;

procedure CabeceParties(var f: text);
  var i: byte;
      cadx: string[13];
      
Begin
  for i:= 1 to MaxPartiPrint do
    begin
      str(i,cadx);
      cadx:= 'Party'+cadx;
      write(f, sepacsv); write(f, '"'+cadx+'"');
      write(f, sepacsv); write(f, '"'+cadx+'.Vote"');
      write(f, sepacsv); write(f, '"'+cadx+'.Seat"');
    end;  
End;

procedure CabeceDDcsv(var f: text; NoNiveleUt, IndNivelAgrMx: byte);

Begin  
  CabeItemLevels(f, NoNiveleUt, IndNivelAgrMx);
  CabeceIndics(f, 'listDD',1, NNIndexs);
  CabeceParties(f);
  writeln(f);
  flush(f);
End;

procedure MatrDDCSV(var camino: TcaminFi;
                    NoNiveleUt, IndNivelAgrMx: byte);

 var IndNivel: byte;
     f: text; 
Begin
  assign(f, camino+'matrizDD.csv');   rewrite(f);

  CabeceDDcsv(f, NoNiveleUt, IndNivelAgrMx);

  for IndNivel:= IndNivelAgrMx to NoNiveleUt do
      MtCSVDDxNivel(f, camino, IndNivel);

  close(f);
End;
{ ************************************************************ }


procedure  MtCSVRegxNiv(var f: text;  var camino: TcaminFi;
                        IndAmbSup, IndAmbInf: byte);

  const NoRegIni = EqNo+1 + nnRegi0Fi;

  label otroNivelAS;

  var iAmbSup: TItmsNivel;
      vNivAmbSup: TRegNivel;
      gout: Tfichero;
      r, totPANE, totENP, mENP, wENP: Tnumero;
      it, NoItms: TItmsNivel;

Begin
  iAmbSup:= 0;

  while GetItm(camino, vNivAmbSup, IndAmbSup, iAmbSup) do
    begin
      NombraFichReg(gout, camino, IndAmbSup, IndAmbInf, vNivAmbSup, 'REG');
      {$I-}
      reset(gout);
      {$I+}

      if IoResult <> 0 then goto otroNivelAS;

      read(gout, r);        NoItms:= trunc(r);
      read(gout, totPANE, totENP, mENP, wENP);

      seek(gout, NoRegIni);

      for it:= 0 to NoItms do
        begin
          write(f, Succ(IndAmbSup)); write(f, sepacsv);

          write(f, Succ(IndAmbInf)); 

          MatNivelCSV(f, vNivAmbSup);

          escridatCSV(f, totPANE, FALSE);
          escridatCSV(f, totENP, FALSE);

          escridatCSV(f, mENP, FALSE);

          r:=inflationCox(totENP, mENP);
          escridatCSV(f, r, FALSE);         

          r:=inflationMoKa(totENP, mENP);
          escridatCSV(f, r, FALSE);  

          escridatCSV(f, wENP, FALSE);

          r:=inflationCox(totENP, wENP);
          escridatCSV(f, r, FALSE);     

          r:=inflationMoKa(totENP, wENP);
          escridatCSV(f, r, FALSE); 

          MtCSV1Itm(f, gout, NNindxFichReg);
          writeln(f);
        end;

      
      close(gout);


      otroNivelAS:
      Inc(iAmbSup);
    end;

  flush(f);
End;

procedure CabeItemLevRR(var f: text; prefi: TnombreFi; NoNiveleUt, IndNivelAgrMx: byte);
 var cad: string[18];
     i: byte;
Begin
  for i:= IndNivelAgrMx to NoNiveleUt do
    begin
      str(Succ(i), cad);
      cad:= '"'+prefi+'.Lev'+cad+'.Code"';
      write(f, sepacsv); write(f, cad);
    end;
 
  cad:= '"'+prefi;
  write(f, sepacsv); write(f, cad+'.Seats"');
  write(f, sepacsv); write(f, cad+'.Votes"');
End;


procedure CabeceRRcsv(var f: text; NoNiveleUt, IndNivelAgrMx: byte);

Begin
  write(f, '"UpLevel"');  write(f, sepacsv);
  write(f, '"LoLevel"');	

  CabeItemLevRR(f, 'Up', NoNiveleUt, IndNivelAgrMx);
  CabeceIndics(f, 'listRR', 1, 8);

  CabeItemLevRR(f, 'Lo', NoNiveleUt, IndNivelAgrMx);

  CabeceIndics(f, 'listRR', 9, 16);

  writeln(f);
  flush(f);
End;




procedure MtCSVRegional(var camino: TcaminFi;
                        NoNiveleUt, IndNivelAgrMx: byte);

  var iAS, iAI: byte;
       f: text; 


Begin
  assign(f, camino+'matriREG.csv');   rewrite(f);

  CabeceRRcsv(f, NoNiveleUt, IndNivelAgrMx);

  for iAS:= IndNivelAgrMx to NoNiveleUt do
    for iAI:= Succ(iAS) to NoNiveleUt do
           MtCSVRegxNiv(f, camino, iAS, iAI);

  close(f);
End;


procedure CabeceIncre(var f: text; vold: TRgPartido);
  var i: TRgPartido;
      cadx: string[13];
      cad2: string[3];

Begin
  for i:= 1 to Succ(vold) do
    begin
      str(i,cad2);
      cadx:= 'Party'+cad2+'.Inc';
      write(f, sepacsv); write(f, '"e.'+cadx+'"');
      write(f, sepacsv); write(f, '"p.'+cadx+'"');
    end;
End;

procedure CabeceVolcsv(var f: text; NoNiveleUt, IndNivelAgrMx: byte;
                       vold: TRgPartido);
Begin
  write(f, '"Elec2"');  write(f, sepacsv);
  write(f, '"Elec1"');  write(f, sepacsv);
  CabeItemLevels(f, NoNiveleUt, IndNivelAgrMx);
  CabeceIndics(f, 'listVol', 1, 14);
  CabeceIncre(f,vold);
  writeln(f);
End;


procedure MCSVVolatxNiv(var f: text; var cami2: TcaminFi;
                     NoNiveleUt, IndNivelAgrMx, IndiNivel: byte);

  var g: Tfichero;
      itm, NoItms: TItmsNivel;
      Cg2, Cg1, NoMedsv: word;
      r: Tnumero;
      voldx: TRgPartido;


Begin
  NombraFichVol(g, cami2, IndiNivel);
  {$I-}
  reset(g);
  {$I+}

  if IoResult <> 0 then exit;

  read(g, r);    NoItms:= trunc(r);
  read(g, r);
  read(g,r);     voldx:= trunc(r);
  read(g, r);    Cg2:= trunc(r);
  read(g, r);    Cg1:= trunc(r);

  if IndiNivel =  IndNivelAgrMx then
    CabeceVolcsv(f, NoNiveleUt, IndNivelAgrMx, voldx);

  NoMedsv:= 14 + 2*(voldx+1);

  for itm:= 0 to NoItms do
    begin
      write(f, Cg2); write(f, sepacsv);
      write(f, Cg1); write(f, sepacsv);

      write(f, Succ(IndiNivel)); 

      MtCSV1Itm(f, g, NoMedsv);
      writeln(f);
    end;

  close(g);
  flush(f);
End;



procedure MCSVVolatilidad(var cami2: TcaminFi;
                          var infoFixx: TOInfoFich;
                          NoNiveleUt, IndNivelAgrMx: byte);

  var IndiNiv: byte;
      f: text;
Begin
  assign(f, infoFixx.camin+'matVolat.csv');   rewrite(f);

  for IndiNiv:= IndNivelAgrMx to NoNiveleUt do
   MCSVVolatxNiv(f, cami2, NoNiveleUt, IndNivelAgrMx, IndiNiv);

  close(f);
End;

End.
