{ =====================================================
 Copyright (C) 2007 Francisco A. Ocana & Pablo Onate 

 This file is part of IndElec

 IndElec is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 IndElec is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You have received a copy of the GNU General Public License
 in a file called COPYING which you should have received with
 IndElec. If not, see <http://www.gnu.org/licenses/>.
 ===================================================== 
}
unit UMATRICI;

{
Create the text files with matrix data style from the ouput
of IndElec
}

INTERFACE

uses COMUN;

procedure MatriDD(var camino: TcaminFi;
                  NoNiveleUt, IndNivelAgrMx: byte);

procedure MatriRegional(var camino: TcaminFi;
                        NoNiveleUt, IndNivelAgrMx: byte);

procedure MatriVolatilidad(var cami2: TcaminFi; var infoFixx: TOInfoFich;
                           NoNiveleUt, IndNivelAgrMx: byte);



IMPLEMENTATION

uses DEFNIVEL, DIMDEFN,
     DIMAUXN,  COMUTIL, DIMSIGLA,
     DIMENSIU, DIMREG, VOLADIM;

const tabu = 15;
      preci = 4;
      


procedure MatNivel(var f: text; var vNivec: TRegNivel);
  var i: byte;
Begin
  for i:= vNivec.IndNiveAgrMax to vNivec.NoNiveleUti do
            write(f, vNivec.CgClasifica[i]: tabu);

  write(f, vNivec.tamano: tabu);
  escridatEE(f, vNivec.votos, tabu, 2, FALSE, FALSE);
End;


procedure Mat1Itm(var f: text;
                  var gout: Tfichero; NoMedidas: word);

  var vNivec: TRegNivel;
      i: word;
      r: Tnumero;

Begin
  ReadNivel(gout, vNivec);

  MatNivel(f, vNivec);

  for i:= 1 to NoMedidas do
    begin
      read(gout, r);
      escridat(f, r, tabu, preci, FALSE, FALSE);      
    end;
   
End;

procedure MatPartiesItm(var f: text; var gPou: TfichParty);

 var PaO: TParty;
     i, noParti: TRgPartido;
     k: byte;

Begin
  read(gPou, PaO);
  noParti:= trunc(PaO.Ep);

  for i:= 0 to noParti do
    begin
      read(gPou, PaO);
      
      if i < MaxPartiPrint then
        begin
          write(f, PaO.SiglasCandi:Succ(lenCandida));
          escridat(f, PaO.Vp, tabu, preci, FALSE, FALSE);
          escridat(f, PaO.Ep, tabu, preci, FALSE, FALSE);
        end;
    end;


  { Case: 1+noParti < maxPartyPrint }
  if Succ(noParti) < MaxPartiPrint then
    begin
      for i:=1 to MaxPartiPrint-Succ(noParti) do
        begin 
          for k:= 1 to 3 do write(f, ' ':tabu);
        end;
    end;

  
End;

procedure MatriDDxNivel(var f: text;
                        var camino: TcaminFi;
                        IndiNivel: byte);

 var gout: Tfichero;
     r: Tnumero;
     it, NoItms: TItmsNivel;
     gPou: TfichParty;


Begin
  NombraFichDim(gout, camino, IndiNivel);
  reset(gout);

  if IoResult <> 0 then exit;

  NombraFichPartyD(gPou, camino, IndiNivel);
  reset(gPou);

  if IoResult <> 0 then
    begin
      close(gout);
      exit;
    end;

  read(gout, r);   NoItms:= trunc(r);
  read(gout, r);

  for it:= 0 to NoItms do
    begin
      write(f, Succ(IndiNivel): tabu);

      Mat1Itm(f, gout, NNIndexs);
      MatPartiesItm(f, gPou);
      writeln(f);
    end;

  close(gout);
  close(gPou);
  flush(f)
End;


procedure CabeceIndiTXT(var f: text; nom: TnombreFi; iini, ifin: byte);

  var fhead: text;
      i: byte;
      nomx: string[20];

Begin
  nomx:= nom+'.txt';
  assign(fhead, camIndElec+nomx); reset(fhead);
  readln(fhead);  readln(fhead);

  for i:= 1 to ifin do
    begin  
      leeCadenBlank(fhead,@nomx,14);
      if i < iini then continue;               
      write(f, nomx:tabu);    
    end;

  close(fhead);
End;

procedure CabeItemLevelsTXT(var f: text; NoNiveleUt, IndNivelAgrMx: byte);
 var cad: string[12];
     i: byte;
Begin
  write(f, 'Level':tabu);
  for i:= IndNivelAgrMx to NoNiveleUt do
    begin
      str(Succ(i), cad);
      cad:= 'Lev'+cad+'.Code';
      write(f, cad:tabu);
    end;

  write(f, 'Seats':tabu);
  write(f, 'Votes':tabu);
End;

procedure CabecePartieTXT(var f: text);
  var i: byte;
      cadx: string[8];
      cady: string[13];
      
Begin
  for i:= 1 to MaxPartiPrint do
    begin
      str(i,cadx);
      cadx:= 'Party'+cadx;
      write(f, cadx:Succ(lenCandida));
      cady:=  cadx+'Vote';  write(f, cady:tabu);
      cady:= cadx+'Seat';   write(f, cady:tabu);
    end;  
End;

procedure CabeceDDtxt(var f: text; NoNiveleUt, IndNivelAgrMx: byte);

Begin  
  CabeItemLevelsTXT(f, NoNiveleUt, IndNivelAgrMx);
  CabeceIndiTXT(f, 'listDD',1, NNIndexs);
  CabecePartieTXT(f);
  writeln(f);
End;

procedure MatriDD(var camino: TcaminFi;
                  NoNiveleUt, IndNivelAgrMx: byte);

 var IndNivel: byte;
     f: text;

Begin
  assign(f, camino+'matrizDD.txt');   rewrite(f);

  CabeceDDtxt(f, NoNiveleUt, IndNivelAgrMx);
  for IndNivel:= IndNivelAgrMx to NoNiveleUt do
        MatriDDxNivel(f, camino, IndNivel);

  close(f);
End;
{ ************************************************************ }

procedure  MatriRegxNiv(var f: text;
                        var camino: TcaminFi;
                        IndAmbSup, IndAmbInf: byte);

  const NoRegIni = EqNo+1 + nnRegi0Fi;

  label otroNivelAS;

  var iAmbSup: TItmsNivel;
      vNivAmbSup: TRegNivel;
      gout: Tfichero;
      r, totPANE, totENP, mENP, wENP: Tnumero;
      it, NoItms: TItmsNivel;

Begin
  iAmbSup:= 0;

  while GetItm(camino, vNivAmbSup, IndAmbSup, iAmbSup) do
    begin
      NombraFichReg(gout, camino, IndAmbSup, IndAmbInf, vNivAmbSup, 'reg');
      {$I-}
      reset(gout);
      {$I+}

      if IoResult <> 0 then goto otroNivelAS;

      read(gout, r);        NoItms:= trunc(r);
      read(gout, totPANE, totENP, mENP, wENP);

      seek(gout, NoRegIni);

      for it:= 0 to NoItms do
        begin
          write(f, Succ(IndAmbSup): tabu);
          write(f, Succ(IndAmbInf): tabu);

          MatNivel(f, vNivAmbSup);

          escridat(f, totPANE, tabu, preci, FALSE, FALSE);
          escridat(f, totENP, tabu, preci, FALSE, FALSE);  
        
          escridat(f, mENP, tabu, preci, FALSE, FALSE);

          r:=inflationCox(totENP, mENP);
          escridat(f, r, tabu, preci, FALSE, FALSE);         

          r:=inflationMoKa(totENP, mENP);
          escridat(f, r, tabu, preci, FALSE, FALSE);          

          escridat(f, wENP, tabu, preci, FALSE, FALSE);
          
          r:=inflationCox(totENP, wENP);
          escridat(f, r, tabu, preci, FALSE, FALSE);    

          r:=inflationMoKa(totENP, wENP);
          escridat(f, r, tabu, preci, FALSE, FALSE);
          
          Mat1Itm(f, gout, NNindxFichReg);
          writeln(f);
        end;

      
      close(gout);


      otroNivelAS:
      Inc(iAmbSup);
    end;

  flush(f); 
End;


procedure CabeItemLevRRtxt(var f: text; prefi: TnombreFi; NoNiveleUt, IndNivelAgrMx: byte);
 var cad: string[18];
     i: byte;
Begin
  for i:= IndNivelAgrMx to NoNiveleUt do
    begin
      str(Succ(i), cad);
      cad:= prefi+'.Lev'+cad+'Code';
      write(f, cad:tabu);
    end;
 
  cad:= prefi;
  write(f, cad+'.Seats':tabu);
  write(f, cad+'.Votes':tabu);
End;


procedure CabeceRRtxt(var f: text; NoNiveleUt, IndNivelAgrMx: byte);

Begin
  write(f, 'UpLevel':tabu);  
  write(f, 'LoLevel':tabu);	

  CabeItemLevRRtxt(f, 'Up', NoNiveleUt, IndNivelAgrMx);
  CabeceIndiTXT(f, 'listRR', 1, 8);

  CabeItemLevRRtxt(f, 'Lo', NoNiveleUt, IndNivelAgrMx);

  CabeceIndiTXT(f, 'listRR', 9, 16);

  writeln(f);
  flush(f);
End;



procedure MatriRegional(var camino: TcaminFi;
                        NoNiveleUt, IndNivelAgrMx: byte);

  var iAS, iAI: byte;
      f: text;

Begin
  assign(f, camino+'matriREG.txt');   rewrite(f);

  CabeceRRtxt(f, NoNiveleUt, IndNivelAgrMx);

  for iAS:= IndNivelAgrMx to NoNiveleUt do
    for iAI:= Succ(iAS) to NoNiveleUt do
           MatriRegxNiv(f, camino, iAS, iAI);

  close(f);
End;



procedure CabeceIncreTXT(var f: text; vold: TRgPartido);
  var i: TRgPartido;
      cadx: string[13];
      cad2: string[3];

Begin
  for i:= 1 to Succ(vold) do
    begin
      str(i,cad2);
      cadx:= 'Party'+cad2+'.Inc';
      write(f, 'e.'+cadx:tabu);
      write(f, 'p.'+cadx:tabu);
    end;
End;

procedure CabeceVoltxt(var f: text; NoNiveleUt, IndNivelAgrMx: byte;
                       vold: TRgPartido);
Begin
  write(f, 'Elec2':tabu);  
  write(f, 'Elec1':tabu);  
  CabeItemLevelsTXT(f, NoNiveleUt, IndNivelAgrMx);
  CabeceIndiTXT(f, 'listVol', 1, 14);
  CabeceIncreTXT(f,vold);
  writeln(f);
  flush(f);
End;


procedure MatrVolatixNiv(var f: text; var cami2: TcaminFi;
                         NoNiveleUt, IndNivelAgrMx, IndiNivel: byte);

  var g: Tfichero;
      itm, NoItms: TItmsNivel;
      Cg2, Cg1, NoMedsv: word;
      r: Tnumero;
      voldx: TRgPartido;
     

Begin
  NombraFichVol(g, cami2, IndiNivel);
  {$I-}
  reset(g);
  {$I+}

  if IoResult <> 0 then exit;

  read(g, r);    NoItms:= trunc(r);
  read(g, r);
  read(g,r);     voldx:= trunc(r);
  read(g, r);    Cg2:= trunc(r);
  read(g, r);    Cg1:= trunc(r);

  if IndiNivel =  IndNivelAgrMx then
    CabeceVoltxt(f, NoNiveleUt, IndNivelAgrMx, voldx);


  NoMedsv:= 14 + 2*(voldx+1);

  for itm:= 0 to NoItms do
    begin
      write(f, Cg2: tabu);
      write(f, Cg1: tabu);

      write(f, Succ(IndiNivel): tabu); 

      Mat1Itm(f, g, NoMedsv);
      writeln(f);
    end;

  close(g);
  flush(f);
End;



procedure MatriVolatilidad(var cami2: TcaminFi;
                           var infoFixx: TOInfoFich; 
                           NoNiveleUt, IndNivelAgrMx: byte);

  var IndiNiv: byte;
      f: text;
Begin
  assign(f, infoFixx.camin+'matVolat.txt');   rewrite(f);

  for IndiNiv:= IndNivelAgrMx to NoNiveleUt do
   MatrVolatixNiv(f, cami2, NoNiveleUt, IndNivelAgrMx, IndiNiv);

  close(f);
End;

END.
