{ =====================================================
 Copyright (C) 2007 Francisco A. Ocana & Pablo Onate 

 This file is part of IndElec

 IndElec is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 IndElec is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You have received a copy of the GNU General Public License
 in a file called COPYING which you should have received with
 IndElec. If not, see <http://www.gnu.org/licenses/>.
 ===================================================== 
}
unit UNIVELES;

INTERFACE

uses COMUN, DEFNIVEL;


function IniciarNiveles(var camino: TcaminFi;
                        NoNiveleUt, IndNivelMx: byte;
                        var Mnivel: TMatrNivel): boolean;


IMPLEMENTATION

uses DIMSIGLA;



procedure iniRegistrNivel(var vNive: TRegNivel;
                      IndiNivel, NoNiveleUt, IndNivelMx: byte;
                      var Mnivel: TMatrNivel;
                      var nomNiv: TnombreFi;
                      noNiv: TItmsNivel);
{
This procedure initializes the information of the initial record of a file
for an aggregation level.
}
  var j: byte;

Begin
  vNive.CgClasifica[IndNivelMx]:= Mnivel[IndNivelMx]^[1];

  for j:= Succ(IndiNivel) to NoNiveleUt do
    vNive.CgClasifica[j] := Mnivel[j]^[ Mnivel[j]^[0] ];

  vNive.NoNiveleUti:= NoNiveleUt;
  vNive.IndNiveAgrMax:= IndNivelMx;
  vNive.NomNivel:= nomNiv;
  vNive.tamano:= noNiv;

  vNive.votos:= 0;  { initialization (no meaning) }
End;
{ ************************************************************************ }


function IniNivel(var camino: TcaminFi;
                  IndiNivel,  NoNiveleUt, IndNivelMx: byte;
                  var Mnivel: TMatrNivel): boolean;

  var vNive: TRegNivel;
      fnivel: TfichNivel;
      ft: text;
      noNiv, iv, contaItm: TItmsNivel;
      nomNiv: TnombreFi;
      j: byte;

Begin
  tomaNombreNivel(nomNiv, IndiNivel);

  {$I-}
  assign(ft, camIndElec+nomNiv+'.txt');
  reset(ft);
  {$I+}

  if IoResult <> 0 then
    begin
      IniNivel:= TRUE;
      exit;
    end;

  assign(fnivel, camino+nomNiv+'.cg');   rewrite(fnivel);

  readln(ft, noNiv);   Dec(noNiv);

  iniRegistrNivel(vNive, IndiNivel, NoNiveleUt, IndNivelMx,
                  Mnivel, nomNiv, noNiv);

  write(fnivel, vNive);

  contaItm:= 0;

  for iv:= 0 to noNiv do
    begin
      for j:= IndiNivel downto 1 do
        begin
          if j = 1
          then
              readln(ft, vNive.CgClasifica[j])
          else
              read(ft, vNive.CgClasifica[j]);
        end;

      leeCadenaLn(ft, @(vNive.NomNivel), lenCadItmNiv);
      readln(ft);

      if vNive.CgClasifica[IndNivelMx] = Mnivel[IndNivelMx]^[1] then
        begin
          Inc(contaItm);
          write(fnivel, vNive);
        end;
    end;

  close(ft);

  IniNivel:= FALSE;

  if contaItm = 0
  then
    begin
      close(fnivel);

      assign(fnivel, camino+nomNiv+'.cg');   erase(fnivel);
    end
  else
    begin
      Dec(contaItm);

      if contaItm < noNiv then
        begin
          seek(fnivel, 0);
          iniRegistrNivel(vNive, IndiNivel, NoNiveleUt, IndNivelMx, Mnivel,
                          nomNiv, contaItm);
          write(fnivel, vNive);
        end;

      close(fnivel);
    end;
End;
{ ***************************************************************** }

function IniNivel0(var camino: TcaminFi;  NoNiveleUt: byte;
                   var Mnivel: TMatrNivel): boolean;

  var vNive: TRegNivel;
      fnivel: TfichNivel;
      nomv: TnombreFi;
      j: byte;

Begin
  j:= 0;
  tomaNombreNivel(nomv, j);

  assign(fnivel, camino+nomv+'.cg');   rewrite(fnivel);

  vNive.NoNiveleUti:= NoNiveleUt;
  vNive.IndNiveAgrMax:= 0;
  vNive.nomNivel:= nomv;
  vNive.tamano:= 0;
  vNive.CgClasifica[0]:= Mnivel[0]^[1];
  vNive.votos:= 0;

  for j:= 1 to NoNiveleUt do
     vNive.CgClasifica[j]:= Mnivel[j]^[ Mnivel[j]^[0] ];

  write(fnivel, vNive, vNive);

  close(fnivel);

  IniNivel0:= FALSE;
End;
{ ********************************************************* }

function IniciNivel(var camino: TcaminFi;
                  IndiNivel, NoNiveleUt, IndNivelMx: byte;
                  var Mnivel: TMatrNivel): boolean;

Begin
  if IndiNivel = 0
  then
  iniciNivel:= IniNivel0(camino, NoNiveleUt, Mnivel)
  else
  iniciNivel:= IniNivel(camino, IndiNivel, NoNiveleUt, IndNivelMx, Mnivel);
End;
{ *********************************************************** }


function IniciarNiveles(var camino: TcaminFi;
                        NoNiveleUt, IndNivelMx: byte;
                        var Mnivel: TMatrNivel): boolean;
{
 Auxiliary routines for constructing the binary files *.CG containing
 the information for each of the considered aggregation levels.
 This binary files contain of the information on items or 
 regional units in each level.

 Crea los ficheros de registros *.cg, camino+nombreNivelAgrega+'.cg',
 para cada uno de los niveles de agregacin considerados.
 Cada uno de estos ficheros contiene los cdigos de los items considerados en cada nivel
 de agregacin, considerando la estructura de niveles especificada en la
 cabecera del fichero de datos camino+'partido.bda'.
}

  var IndiNivel: byte;

Begin
  for IndiNivel:= IndNivelMx to NoNiveleUt do
    if iniciNivel(camino, IndiNivel, NoNiveleUt, IndNivelMx, Mnivel) then
      begin
        IniciarNiveles:= TRUE;
        exit;
      end;

  IniciarNiveles:= FALSE;
End;

END.
