{ =====================================================
 Copyright (C) 2007 Francisco A. Ocana & Pablo Onate 

 This file is part of IndElec

 IndElec is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 IndElec is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You have received a copy of the GNU General Public License
 in a file called COPYING which you should have received with
 IndElec. If not, see <http://www.gnu.org/licenses/>.
 ===================================================== 
}
unit VOLAINOU;

{
Create the text file with report style from the output of
the module Volatili with data aggregation levels.

}


INTERFACE

uses COMUN;

procedure ShowVolTXT(var cami1, cami2: TcaminFi; var infoFixx: TOInfoFich;
                     NoNiveleUt, IndNivelAgrMx: byte);



IMPLEMENTATION

uses defNivel, comUtil,
     dimSigla, dimVecto, dimAuxn, uInpOut,
     VolaDim,membrete,voldef, cabecera;

  const tabu = 7;
        preci = 2;
        NoRegIni = 5;
        NoRegsItm = EqNo + 15;    { EqNo + 1 + 4 + 5 + 5 }




procedure ShowNiveVol(var fout: text;  IndiNivel: byte;  var cami2: TcaminFi;
                      var gout: Tfichero;  var dNoRgsItmV: word);



 var
     iv, NoItms: TItmsNivel;
     rVoto, rEsca, acVoto, acEsca: Tnumero;
     vNiv: TRegNivel;
     nomNive: TnombreFi;
     posici: word;

Begin
  tomaNombreNivel(nomNive, IndiNivel);

  writeln(fout);
  write(fout, 'List of items for the aggregation level ');
  write(fout, nomNive);
  writeln(fout, ' :');

  writeln(fout);
  write(fout, nomNive: lenCadItmNiv);    write(fout, charTabu);
  write(fout, 'Votes': 13);         write(fout, charTabu);
  write(fout, 'Seats ':12);        write(fout, charTabu);

  write(fout, '%Votes-2':12);        write(fout, charTabu);
  write(fout, '%Seats-2':12);      write(fout, charTabu);
  write(fout, '%Votes-1':12);       write(fout, charTabu);
  write(fout, '%Seats-1':12);     writeln(fout);

  write(fout, '************':lenCadItmNiv);  write(fout, charTabu);
  write(fout, '*******':13);            write(fout, charTabu);
  write(fout, '******':12);              write(fout, charTabu);

  write(fout, '******':12);              write(fout, charTabu);
  write(fout, '******':12);              write(fout, charTabu);
  write(fout, '******':12);              write(fout, charTabu);
  write(fout, '******':12);              writeln(fout);


  NombraFichVol(gout, cami2, IndiNivel);
  reset(gout);

  read(gout, rVoto);   NoItms:= trunc(rVoto);

  read(gout, rVoto);
  read(gout, rVoto);   dNoRgsItmV:= trunc(rVoto);
  dNoRgsItmV:= NoRegsItm + 2*(dNoRgsItmV+1);

  posici:= 5;
  acVoto:= 0;       acEsca:= 0;

  for iv:= 0 to NoItms do
    begin
      seek(gout, posici);
      ReadNivel(gout, vNiv);

      write(fout, vNiv.NomNivel:lenCadItmNiv);
      write(fout, charTabu);
      escridatEE(fout, vNiv.votos, 13, 0, TRUE, FALSE);
      escridatEE(fout, vNiv.tamano, 12, 0, TRUE, FALSE);

      acVoto:= acVoto + vNiv.votos;
      acEsca:= acEsca + vNiv.tamano;

      read(gout, rVoto, rEsca);
      escridat(fout, rVoto, 12, 2, TRUE, FALSE);
      escridat(fout, rEsca, 12, 2, TRUE, FALSE);

      read(gout, rVoto, rEsca);
      escridat(fout, rVoto, 12, 2, TRUE, FALSE);
      escridat(fout, rEsca, 12, 2, TRUE, TRUE);

      posici:= posici+ dNoRgsItmV;

    end;


  writeln(fout);
  write(fout, 'SUM ':lenCadItmNiv);   write(fout, charTabu);
  escridatEE(fout, acVoto, 13, 0, TRUE, FALSE);
  escridatEE(fout, acEsca, 12, 0, TRUE, TRUE);
  writeln(fout);
  writeln(fout);

  flush(fout);
End;



procedure ShowVolatil(var fout: text; var gout: Tfichero;
                      ClaseDistrito: boolean;
                      var dNoRgsItmV: word);


  var
      NoItms: TItmsNivel;
      med: PVector;
      Rc: PMatrix;

Begin
  ShowSignifica('volat', 'b', fout);
  cabeVolatil(fout);


  ShowMedidax(fout, gout, NoItms, NoRegIni, 5, 10, tabu, preci, dNoRgsItmV);

  if NoItms > 0 then
    begin
      ShowEstimas(fout, gout, NoItms, NoRegIni, 5, 10,
                     tabu, preci, dNoRgsItmV, med, Rc, cdistri);

      if ClaseDistrito  then
        ShowEstimaClase(fout, gout, NoItms, NoRegIni, 5, 10,
                     tabu, preci, dNoRgsItmV, med, Rc, cdistri);

    end;

  close(gout);
End;


procedure ShowVolatilidad(var fout: text;
                          var cami2: TcaminFi;
                          NoNiveleUt, IndNivelAgrMx: byte);

  var IndAmb: byte;
      gout: Tfichero;
      dNoRgsItmV: word;
Begin
  for IndAmb:= IndNivelAgrMx to NoNiveleUt do
    begin
      ShowNiveVol(fout, IndAmb, cami2, gout, dNoRgsItmV);
      ShowVolatil(fout, gout, (IndAmb > 1), dNoRgsItmV);
    end;
End;


procedure ShowVolTXT(var cami1, cami2: TcaminFi; var infoFixx: TOInfoFich;
                     NoNiveleUt, IndNivelAgrMx: byte);

var fout: text;
Begin
  assign(fout, infoFixx.camin+infoFixx.nom+'.res');    rewrite(fout);

  MmbrIndxNiv(fout, 1, 't');

  write(fout, 'Period 2 : ');     writeln(fout, cami2);
  write(fout, 'Period 1 : ');     writeln(fout, cami1);

  write(fout, 'Volatility : ');
  writeln(fout, infoFixx.camin+infoFixx.nom+'.ivo');

  ShowSimbolo(fout);
  ShowVolatilidad(fout, cami2, NoNiveleUt, IndNivelAgrMx);

  close(fout);
End;

{ The End of VolaInOu }
END.
