{ =====================================================
 Copyright (C) 2007 Francisco A. Ocana & Pablo Onate 

 This file is part of IndElec

 IndElec is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 IndElec is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You have received a copy of the GNU General Public License
 in a file called COPYING which you should have received with
 IndElec. If not, see <http://www.gnu.org/licenses/>.
 ===================================================== 
}
unit VOLDEF;

{$N+,E-}


{
Define the structures for the party experienced increments and 
for the blocs of parties. Some routines for initializing and showing
the structure of blocs defined by the user are also included in
this unit.
}


INTERFACE

uses COMUN;

const
   MaxNoBloqsVol = 3; {Maximun number (-1) of blocs of parties}

type
    TSimbAfili = array[0..MaxNoBloqsVol] of char;

    TVolati = record
       cbloque: char;
       Vp,
       Ep: Tnumero;
    end;

    TVecVolati = array[0..NoMaxParti] of TVolati;

    PVecVolati = ^TVecVolati;


procedure IniSimbolo(var vSimbo: TSimbAfili; var NoBloqVol: byte);

procedure iniVolatili(var Pvol: PVecVolati; var dimVol: TRgPartido);

procedure ShowSimbolo(var fout: text);

IMPLEMENTATION

{ ******************************************************************** }



procedure iniVolatili(var Pvol: PVecVolati; var dimVol: TRgPartido);

  var i: TRgPartido;
      ft: text;


Begin
  assign(ft, camIndElec+'ALafili.vox');    reset(ft);

  readln(ft, dimVol);
  GetMem(Pvol, sizeOf(TVolati) * TlongNatural(Succ(dimVol)) );

  readln(ft);  readln(ft); {skip the first 2 lines }

  for i:= 0 to dimVol do
    begin
      readln(ft, Pvol^[i].cbloque);

      Pvol^[i].Vp:= 0;
      Pvol^[i].Ep:= 0;
    end;

  close(ft);
End;
{ ******************************************************************** }

procedure IniSimbolo(var vSimbo: TSimbAfili; var NoBloqVol: byte);
 var
     i: byte;
     cAfi: char;
     f: text;

Begin
  assign(f, camIndElec+'simbolos.afi');  reset(f);

  readln(f, NoBloqVol);
  Dec(NoBloqVol);

  if (NoBloqVol > MaxNoBloqsVol) then NoBloqVol:= MaxNoBloqsVol;

  for i:= 0 to NoBloqVol do
    begin
      readln(f, cAfi);
      vSimbo[i] := UpCase(cAfi);
    end;

  close(f);
End;
{ ************************************************************ }

procedure ShowSimbolo(var fout: text);
 var
     i, NoBloqVol: byte;
     cAfi: string[50];
     fs: text;


Begin
  assign(fs, camIndElec+'simbolos.afi');  reset(fs);

  readln(fs, NoBloqVol);
  Dec(NoBloqVol);

  if (NoBloqVol > MaxNoBloqsVol) then NoBloqVol:= MaxNoBloqsVol;

  writeln(fout);  writeln(fout);
  write(fout, 'The considered blocs of political parties (No. blocs = ');
  write(fout, Succ(NoBloqVol));
  writeln(fout, ') : ');

  for i:= 0 to NoBloqVol do
    begin
      readln(fs, cAfi);
      writeln(fout, cAfi);
    end;

  close(fs);
  flush(fout);
End;
{ ************************************************************ }
END.
