{ =====================================================
 Copyright (C) 2007 Francisco A. Ocana & Pablo Onate 

 This file is part of IndElec

 IndElec is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 IndElec is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You have received a copy of the GNU General Public License
 in a file called COPYING which you should have received with
 IndElec. If not, see <http://www.gnu.org/licenses/>.
 ===================================================== 
}
unit VOLINOUH;
{ 
Create the HTML file with report style from the output of
the module Volatili with data aggregation levels.


versin HTML de volaInOu 
}

interface

uses COMUN;

procedure ShowVolHTML(var cami1, cami2: TcaminFi; var infoFixx: TOInfoFich;
                      NoNiveleUt, IndNivelAgrMx: byte);


implementation

uses UHTML, DEFNIVEL, COMUTIL,
     DIMSIGLA, DIMVECTO, DIMAUXN, UINPOUT,
     VOLADIM,MEMBRETE,VOLDEF, CABECERA;

  const preci = 2;
        NoRegIni = 5;
        NoRegsItm = EqNo + 15;    { EqNo + 1 + 4 + 5 + 5 }





procedure ShowNiveVolHH(var fout: text;  IndiNivel: byte;
                      var cami2: TcaminFi;
                      var gout: Tfichero;
                      var dNoRgsItmV: word);



 var
     iv, NoItms: TItmsNivel;
     rVoto, rEsca, acVoto, acEsca: Tnumero;
     vNiv: TRegNivel;
     nomNive: TnombreFi;
     posici: word;

Begin
  tomaNombreNivel(nomNive, IndiNivel);

  writeln(fout, '<p><b>List of items for the aggregation level  ');
  write(fout, nomNive);
  writeln(fout, ':</b></p>');

  writeln(fout, '<p><table cellspacing="10"> <tr>');
  writeHeadTabla(fout, nomNive, 'l');
  writeHeadTabla(fout, 'Votes', 'r');
  writeHeadTabla(fout, 'Seats', 'r');

  writeHeadTabla(fout, '%Votes-2', 'r');
  writeHeadTabla(fout, '%Seats-2', 'r');
  writeHeadTabla(fout, '%Votes-1', 'r');
  writeHeadTabla(fout, '%Seats-1', 'r');
  writeln(fout, '</tr>');

  NombraFichVol(gout, cami2, IndiNivel);
  reset(gout);

  read(gout, rVoto);   NoItms:= trunc(rVoto);

  read(gout, rVoto);
  read(gout, rVoto);   dNoRgsItmV:= trunc(rVoto);
  dNoRgsItmV:= NoRegsItm + 2*(dNoRgsItmV+1);

  posici:= 5;
  acVoto:= 0;       acEsca:= 0;

  for iv:= 0 to NoItms do
    begin
      seek(gout, posici);
      ReadNivel(gout, vNiv);

      writeln(fout, '<tr>');

      writeHeadTabla(fout, vNiv.NomNivel, 'l');
      escridaEEHT(fout, vNiv.votos, 2);
      escridaEEHT(fout, vNiv.tamano, 2);

      acVoto:= acVoto + vNiv.votos;
      acEsca:= acEsca + vNiv.tamano;

      read(gout, rVoto, rEsca);
      escridaHt(fout, rVoto, 2);
      escridaHt(fout, rEsca, 2);

      read(gout, rVoto, rEsca);
      escridaHt(fout, rVoto, 2);
      escridaHt(fout, rEsca, 2);

      posici:= posici+ dNoRgsItmV;

      writeln(fout, '</tr>');
    end;


  writeln(fout, '<tr> </tr> <tr>');
  writeHeadTabla(fout, 'SUM', 'r');
  escridaEEHT(fout, acVoto, 2);
  escridaEEHT(fout, acEsca, 2);
  writeln(fout, '<td> </td> <td> </td> <td> </td> <td> </td>');

  writeln(fout, '</tr> </table> </p>');

  flush(fout);
End;





procedure iniShoVolHH(var cami1, cami2: TcaminFi; var infoFixx: TOInfoFich;
                     var fout: text);
Begin
  writeln(fout, '<html>');
  writeln(fout, '<head>');
  IntroMetaHTML(fout);
  writeln(fout, '<title>');
  write(fout, 'IndElec-volatility:');
  writeln(fout, infoFixx.camin+infoFixx.nom+'.ivo');
  writeln(fout, '</title> </head> <body>');
  MmbrIndxNiv(fout, 1, 'h');

  writeln(fout, '<p><table cellspacing="8"><tr>');
  writeHeadTabla(fout, 'Period 2:', 'r');
  writeItmTabla(fout, cami2, 'l');

  writeln(fout, '</tr> <tr>');

  writeHeadTabla(fout, 'Period 1:', 'r');
  writeItmTabla(fout, cami1, 'l');

  writeln(fout, '</tr> <tr>');

  writeHeadTabla(fout, 'Volatility:', 'r');
  writeItmTabla(fout, infoFixx.camin+infoFixx.nom+'.ivo', 'l');
  writeln(fout, '</tr> </table></p>');

  writeln(fout, '<pre>');
  ShowSimbolo(fout);
  writeln(fout, '</pre>');
End;


procedure ShowVolatilHH(var fout: text; var gout: Tfichero;
                      ClaseDistrito: boolean;
                      var dNoRgsItmV: word);


  var
      NoItms: TItmsNivel;
      med: PVector;
      Rc: PMatrix;

Begin
  ShowSignifica('volat', 'h', fout);
  cabeVolatilHH(fout);

  ShowMedidaxH(fout, gout, NoItms, NoRegIni, 5, 10, preci, dNoRgsItmV);

  if NoItms = 0
  then
     writeln(fout, '</table></p>')
  else
    begin
      ShowEstimasH(fout, gout, NoItms, NoRegIni, 5, 10,
                     preci, dNoRgsItmV, med, Rc, cdistri);
      if ClaseDistrito  then
        ShowEstimClaseH(fout, gout, NoItms, NoRegIni, 5, 10,
                     preci, dNoRgsItmV, med, Rc, cdistri);

    end;


  close(gout);
End;


procedure ShowVolatilidadHH(var fout: text;
                          var cami2: TcaminFi;
                          NoNiveleUt, IndNivelAgrMx: byte);

  var IndAmb: byte;
      gout: Tfichero;
      dNoRgsItmV: word;
Begin
  for IndAmb:= IndNivelAgrMx to NoNiveleUt do
    begin
      introMarcaHTML(fout, IndAmb, 'mV');
      ShowNiveVolHH(fout, IndAmb, cami2, gout, dNoRgsItmV);
      ShowVolatilHH(fout, gout, (IndAmb > 1), dNoRgsItmV);
    end;
End;


procedure ShowVolHTML(var cami1, cami2: TcaminFi; var infoFixx: TOInfoFich;
                      NoNiveleUt, IndNivelAgrMx: byte);

var fout: text;
Begin
  assign(fout, infoFixx.camin+infoFixx.nom+'.htm');  rewrite(fout);

  iniShoVolHH(cami1, cami2, infoFixx, fout);

  ShowVolatilidadHH(fout, cami2, NoNiveleUt, IndNivelAgrMx);

  writeln(fout, '</body> </html>');
  close(fout);
End;


end.
